/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosInstance } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { AddActivityRequest } from '../models';
import { AddActivityResponse } from '../models';
import { DeleteActivitiesResponse } from '../models';
import { DeleteActivityResponse } from '../models';
import { GetActivitiesCollectionResponse } from '../models';
import { GetActivitiesResponse } from '../models';
import { GetActivityResponse } from '../models';
import { UpdateActivityRequest } from '../models';
import { UpdateActivityResponse } from '../models';
/**
 * ActivitiesApi - axios parameter creator
 * @export
 */
export declare const ActivitiesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Adds a new activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-activity\" target=\"_blank\" rel=\"noopener noreferrer\">adding an activity</a>. <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Add an activity
     * @param {AddActivityRequest} [AddActivityRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    addActivity: (AddActivityRequest?: AddActivityRequest) => Promise<RequestArgs>;
    /**
     * Marks multiple activities as deleted. After 30 days, the activities will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#deleteActivity\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/activities/{id}</a> instead.
     * @summary Delete multiple activities in bulk
     * @param {string} ids The comma-separated IDs of activities that will be deleted
     * @deprecated
     * @throws {RequiredError}
     */
    deleteActivities: (ids: string) => Promise<RequestArgs>;
    /**
     * Marks an activity as deleted. After 30 days, the activity will be permanently deleted.
     * @summary Delete an activity
     * @param {number} id The ID of the activity
     * @deprecated
     * @throws {RequiredError}
     */
    deleteActivity: (id: number) => Promise<RequestArgs>;
    /**
     * Returns all activities assigned to a particular user.
     * @summary Get all activities assigned to a particular user
     * @param {number} [user_id] The ID of the user whose activities will be fetched. If omitted, the user associated with the API token will be used. If 0, activities for all company users will be fetched based on the permission sets.
     * @param {number} [filter_id] The ID of the filter to use (will narrow down results if used together with &#x60;user_id&#x60; parameter)
     * @param {string} [type] The type of the activity, can be one type or multiple types separated by a comma. This is in correlation with the &#x60;key_string&#x60; parameter of ActivityTypes.
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned.
     * @param {number} [start] For pagination, the position that represents the first result for the page
     * @param {string} [start_date] Use the activity due date where you wish to begin fetching activities from. Insert due date in YYYY-MM-DD format.
     * @param {string} [end_date] Use the activity due date where you wish to stop fetching activities from. Insert due date in YYYY-MM-DD format.
     * @param {0 | 1} [done] Whether the activity is done or not. 0 &#x3D; Not done, 1 &#x3D; Done. If omitted returns both done and not done activities.
     * @deprecated
     * @throws {RequiredError}
     */
    getActivities: (user_id?: number, filter_id?: number, type?: string, limit?: number, start?: number, start_date?: string, end_date?: string, done?: 0 | 1) => Promise<RequestArgs>;
    /**
     * Returns all activities. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities</a> instead.
     * @summary Get all activities collection
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [since] The time boundary that points to the start of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {string} [until] The time boundary that points to the end of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {number} [user_id] The ID of the user whose activities will be fetched. If omitted, all activities are returned.
     * @param {boolean} [done] Whether the activity is done or not. &#x60;false&#x60; &#x3D; Not done, &#x60;true&#x60; &#x3D; Done. If omitted, returns both done and not done activities.
     * @param {string} [type] The type of the activity, can be one type or multiple types separated by a comma. This is in correlation with the &#x60;key_string&#x60; parameter of ActivityTypes.
     * @deprecated
     * @throws {RequiredError}
     */
    getActivitiesCollection: (cursor?: string, limit?: number, since?: string, until?: string, user_id?: number, done?: boolean, type?: string) => Promise<RequestArgs>;
    /**
     * Returns the details of a specific activity.
     * @summary Get details of an activity
     * @param {number} id The ID of the activity
     * @deprecated
     * @throws {RequiredError}
     */
    getActivity: (id: number) => Promise<RequestArgs>;
    /**
     * Updates an activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Update an activity
     * @param {number} id The ID of the activity
     * @param {UpdateActivityRequest} [UpdateActivityRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    updateActivity: (id: number, UpdateActivityRequest?: UpdateActivityRequest) => Promise<RequestArgs>;
};
/**
 * ActivitiesApi - functional programming interface
 * @export
 */
export declare const ActivitiesApiFp: (configuration?: Configuration) => {
    /**
     * Adds a new activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-activity\" target=\"_blank\" rel=\"noopener noreferrer\">adding an activity</a>. <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Add an activity
     * @param {AddActivityRequest} [AddActivityRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    addActivity(AddActivityRequest?: AddActivityRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddActivityResponse>>;
    /**
     * Marks multiple activities as deleted. After 30 days, the activities will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#deleteActivity\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/activities/{id}</a> instead.
     * @summary Delete multiple activities in bulk
     * @param {string} ids The comma-separated IDs of activities that will be deleted
     * @deprecated
     * @throws {RequiredError}
     */
    deleteActivities(ids: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteActivitiesResponse>>;
    /**
     * Marks an activity as deleted. After 30 days, the activity will be permanently deleted.
     * @summary Delete an activity
     * @param {number} id The ID of the activity
     * @deprecated
     * @throws {RequiredError}
     */
    deleteActivity(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteActivityResponse>>;
    /**
     * Returns all activities assigned to a particular user.
     * @summary Get all activities assigned to a particular user
     * @param {number} [user_id] The ID of the user whose activities will be fetched. If omitted, the user associated with the API token will be used. If 0, activities for all company users will be fetched based on the permission sets.
     * @param {number} [filter_id] The ID of the filter to use (will narrow down results if used together with &#x60;user_id&#x60; parameter)
     * @param {string} [type] The type of the activity, can be one type or multiple types separated by a comma. This is in correlation with the &#x60;key_string&#x60; parameter of ActivityTypes.
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned.
     * @param {number} [start] For pagination, the position that represents the first result for the page
     * @param {string} [start_date] Use the activity due date where you wish to begin fetching activities from. Insert due date in YYYY-MM-DD format.
     * @param {string} [end_date] Use the activity due date where you wish to stop fetching activities from. Insert due date in YYYY-MM-DD format.
     * @param {0 | 1} [done] Whether the activity is done or not. 0 &#x3D; Not done, 1 &#x3D; Done. If omitted returns both done and not done activities.
     * @deprecated
     * @throws {RequiredError}
     */
    getActivities(user_id?: number, filter_id?: number, type?: string, limit?: number, start?: number, start_date?: string, end_date?: string, done?: 0 | 1): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetActivitiesResponse>>;
    /**
     * Returns all activities. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities</a> instead.
     * @summary Get all activities collection
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [since] The time boundary that points to the start of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {string} [until] The time boundary that points to the end of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {number} [user_id] The ID of the user whose activities will be fetched. If omitted, all activities are returned.
     * @param {boolean} [done] Whether the activity is done or not. &#x60;false&#x60; &#x3D; Not done, &#x60;true&#x60; &#x3D; Done. If omitted, returns both done and not done activities.
     * @param {string} [type] The type of the activity, can be one type or multiple types separated by a comma. This is in correlation with the &#x60;key_string&#x60; parameter of ActivityTypes.
     * @deprecated
     * @throws {RequiredError}
     */
    getActivitiesCollection(cursor?: string, limit?: number, since?: string, until?: string, user_id?: number, done?: boolean, type?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetActivitiesCollectionResponse>>;
    /**
     * Returns the details of a specific activity.
     * @summary Get details of an activity
     * @param {number} id The ID of the activity
     * @deprecated
     * @throws {RequiredError}
     */
    getActivity(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetActivityResponse>>;
    /**
     * Updates an activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Update an activity
     * @param {number} id The ID of the activity
     * @param {UpdateActivityRequest} [UpdateActivityRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    updateActivity(id: number, UpdateActivityRequest?: UpdateActivityRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpdateActivityResponse>>;
};
/**
 * ActivitiesApi - factory interface
 * @export
 */
export declare const ActivitiesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Adds a new activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-activity\" target=\"_blank\" rel=\"noopener noreferrer\">adding an activity</a>. <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Add an activity
     * @param {ActivitiesApiAddActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    addActivity(requestParameters?: ActivitiesApiAddActivityRequest): Promise<AddActivityResponse>;
    /**
     * Marks multiple activities as deleted. After 30 days, the activities will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#deleteActivity\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/activities/{id}</a> instead.
     * @summary Delete multiple activities in bulk
     * @param {ActivitiesApiDeleteActivitiesRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    deleteActivities(requestParameters: ActivitiesApiDeleteActivitiesRequest): Promise<DeleteActivitiesResponse>;
    /**
     * Marks an activity as deleted. After 30 days, the activity will be permanently deleted.
     * @summary Delete an activity
     * @param {ActivitiesApiDeleteActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    deleteActivity(requestParameters: ActivitiesApiDeleteActivityRequest): Promise<DeleteActivityResponse>;
    /**
     * Returns all activities assigned to a particular user.
     * @summary Get all activities assigned to a particular user
     * @param {ActivitiesApiGetActivitiesRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getActivities(requestParameters?: ActivitiesApiGetActivitiesRequest): Promise<GetActivitiesResponse>;
    /**
     * Returns all activities. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities</a> instead.
     * @summary Get all activities collection
     * @param {ActivitiesApiGetActivitiesCollectionRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getActivitiesCollection(requestParameters?: ActivitiesApiGetActivitiesCollectionRequest): Promise<GetActivitiesCollectionResponse>;
    /**
     * Returns the details of a specific activity.
     * @summary Get details of an activity
     * @param {ActivitiesApiGetActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getActivity(requestParameters: ActivitiesApiGetActivityRequest): Promise<GetActivityResponse>;
    /**
     * Updates an activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Update an activity
     * @param {ActivitiesApiUpdateActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    updateActivity(requestParameters: ActivitiesApiUpdateActivityRequest): Promise<UpdateActivityResponse>;
};
/**
 * Request parameters for addActivity operation in ActivitiesApi.
 * @export
 * @interface ActivitiesApiAddActivityRequest
 */
export interface ActivitiesApiAddActivityRequest {
    /**
     *
     * @type {AddActivityRequest}
     * @memberof ActivitiesApiAddActivity
     */
    readonly AddActivityRequest?: AddActivityRequest;
}
/**
 * Request parameters for deleteActivities operation in ActivitiesApi.
 * @export
 * @interface ActivitiesApiDeleteActivitiesRequest
 */
export interface ActivitiesApiDeleteActivitiesRequest {
    /**
     * The comma-separated IDs of activities that will be deleted
     * @type {string}
     * @memberof ActivitiesApiDeleteActivities
     */
    readonly ids: string;
}
/**
 * Request parameters for deleteActivity operation in ActivitiesApi.
 * @export
 * @interface ActivitiesApiDeleteActivityRequest
 */
export interface ActivitiesApiDeleteActivityRequest {
    /**
     * The ID of the activity
     * @type {number}
     * @memberof ActivitiesApiDeleteActivity
     */
    readonly id: number;
}
/**
 * Request parameters for getActivities operation in ActivitiesApi.
 * @export
 * @interface ActivitiesApiGetActivitiesRequest
 */
export interface ActivitiesApiGetActivitiesRequest {
    /**
     * The ID of the user whose activities will be fetched. If omitted, the user associated with the API token will be used. If 0, activities for all company users will be fetched based on the permission sets.
     * @type {number}
     * @memberof ActivitiesApiGetActivities
     */
    readonly user_id?: number;
    /**
     * The ID of the filter to use (will narrow down results if used together with &#x60;user_id&#x60; parameter)
     * @type {number}
     * @memberof ActivitiesApiGetActivities
     */
    readonly filter_id?: number;
    /**
     * The type of the activity, can be one type or multiple types separated by a comma. This is in correlation with the &#x60;key_string&#x60; parameter of ActivityTypes.
     * @type {string}
     * @memberof ActivitiesApiGetActivities
     */
    readonly type?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned.
     * @type {number}
     * @memberof ActivitiesApiGetActivities
     */
    readonly limit?: number;
    /**
     * For pagination, the position that represents the first result for the page
     * @type {number}
     * @memberof ActivitiesApiGetActivities
     */
    readonly start?: number;
    /**
     * Use the activity due date where you wish to begin fetching activities from. Insert due date in YYYY-MM-DD format.
     * @type {string}
     * @memberof ActivitiesApiGetActivities
     */
    readonly start_date?: string;
    /**
     * Use the activity due date where you wish to stop fetching activities from. Insert due date in YYYY-MM-DD format.
     * @type {string}
     * @memberof ActivitiesApiGetActivities
     */
    readonly end_date?: string;
    /**
     * Whether the activity is done or not. 0 &#x3D; Not done, 1 &#x3D; Done. If omitted returns both done and not done activities.
     * @type {0 | 1}
     * @memberof ActivitiesApiGetActivities
     */
    readonly done?: 0 | 1;
}
/**
 * Request parameters for getActivitiesCollection operation in ActivitiesApi.
 * @export
 * @interface ActivitiesApiGetActivitiesCollectionRequest
 */
export interface ActivitiesApiGetActivitiesCollectionRequest {
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof ActivitiesApiGetActivitiesCollection
     */
    readonly cursor?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof ActivitiesApiGetActivitiesCollection
     */
    readonly limit?: number;
    /**
     * The time boundary that points to the start of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @type {string}
     * @memberof ActivitiesApiGetActivitiesCollection
     */
    readonly since?: string;
    /**
     * The time boundary that points to the end of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @type {string}
     * @memberof ActivitiesApiGetActivitiesCollection
     */
    readonly until?: string;
    /**
     * The ID of the user whose activities will be fetched. If omitted, all activities are returned.
     * @type {number}
     * @memberof ActivitiesApiGetActivitiesCollection
     */
    readonly user_id?: number;
    /**
     * Whether the activity is done or not. &#x60;false&#x60; &#x3D; Not done, &#x60;true&#x60; &#x3D; Done. If omitted, returns both done and not done activities.
     * @type {boolean}
     * @memberof ActivitiesApiGetActivitiesCollection
     */
    readonly done?: boolean;
    /**
     * The type of the activity, can be one type or multiple types separated by a comma. This is in correlation with the &#x60;key_string&#x60; parameter of ActivityTypes.
     * @type {string}
     * @memberof ActivitiesApiGetActivitiesCollection
     */
    readonly type?: string;
}
/**
 * Request parameters for getActivity operation in ActivitiesApi.
 * @export
 * @interface ActivitiesApiGetActivityRequest
 */
export interface ActivitiesApiGetActivityRequest {
    /**
     * The ID of the activity
     * @type {number}
     * @memberof ActivitiesApiGetActivity
     */
    readonly id: number;
}
/**
 * Request parameters for updateActivity operation in ActivitiesApi.
 * @export
 * @interface ActivitiesApiUpdateActivityRequest
 */
export interface ActivitiesApiUpdateActivityRequest {
    /**
     * The ID of the activity
     * @type {number}
     * @memberof ActivitiesApiUpdateActivity
     */
    readonly id: number;
    /**
     *
     * @type {UpdateActivityRequest}
     * @memberof ActivitiesApiUpdateActivity
     */
    readonly UpdateActivityRequest?: UpdateActivityRequest;
}
/**
 * ActivitiesApi - object-oriented interface
 * @export
 * @class ActivitiesApi
 * @extends {BaseAPI}
 */
export declare class ActivitiesApi extends BaseAPI {
    /**
     * Adds a new activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-activity\" target=\"_blank\" rel=\"noopener noreferrer\">adding an activity</a>. <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Add an activity
     * @param {ActivitiesApiAddActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof ActivitiesApi
     */
    addActivity(requestParameters?: ActivitiesApiAddActivityRequest): Promise<AddActivityResponse>;
    /**
     * Marks multiple activities as deleted. After 30 days, the activities will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#deleteActivity\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/activities/{id}</a> instead.
     * @summary Delete multiple activities in bulk
     * @param {ActivitiesApiDeleteActivitiesRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof ActivitiesApi
     */
    deleteActivities(requestParameters: ActivitiesApiDeleteActivitiesRequest): Promise<DeleteActivitiesResponse>;
    /**
     * Marks an activity as deleted. After 30 days, the activity will be permanently deleted.
     * @summary Delete an activity
     * @param {ActivitiesApiDeleteActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof ActivitiesApi
     */
    deleteActivity(requestParameters: ActivitiesApiDeleteActivityRequest): Promise<DeleteActivityResponse>;
    /**
     * Returns all activities assigned to a particular user.
     * @summary Get all activities assigned to a particular user
     * @param {ActivitiesApiGetActivitiesRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof ActivitiesApi
     */
    getActivities(requestParameters?: ActivitiesApiGetActivitiesRequest): Promise<GetActivitiesResponse>;
    /**
     * Returns all activities. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities</a> instead.
     * @summary Get all activities collection
     * @param {ActivitiesApiGetActivitiesCollectionRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof ActivitiesApi
     */
    getActivitiesCollection(requestParameters?: ActivitiesApiGetActivitiesCollectionRequest): Promise<GetActivitiesCollectionResponse>;
    /**
     * Returns the details of a specific activity.
     * @summary Get details of an activity
     * @param {ActivitiesApiGetActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof ActivitiesApi
     */
    getActivity(requestParameters: ActivitiesApiGetActivityRequest): Promise<GetActivityResponse>;
    /**
     * Updates an activity. Includes `more_activities_scheduled_in_context` property in response\'s `additional_data` which indicates whether there are more undone activities scheduled with the same deal, person or organization (depending on the supplied data). <br /> <br /> ***Starting from 30.09.2024, activity attendees will receive updates only if the activity owner has an active calendar sync***
     * @summary Update an activity
     * @param {ActivitiesApiUpdateActivityRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof ActivitiesApi
     */
    updateActivity(requestParameters: ActivitiesApiUpdateActivityRequest): Promise<UpdateActivityResponse>;
}
