/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosInstance } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { AddUserProviderLinkRequest } from '../models';
import { GetUserProviderLinkSuccessResponse } from '../models';
/**
 * MeetingsApi - axios parameter creator
 * @export
 */
export declare const MeetingsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * A video calling provider must call this endpoint to remove the link between a user and the installed video calling app.
     * @summary Delete the link between a user and the installed video call integration
     * @param {string} id Unique identifier linking a user to the installed integration

     * @throws {RequiredError}
     */
    deleteUserProviderLink: (id: string) => Promise<RequestArgs>;
    /**
     * A video calling provider must call this endpoint after a user has installed the video calling app so that the new user\'s information is sent.
     * @summary Link a user with the installed video call integration
     * @param {AddUserProviderLinkRequest} [AddUserProviderLinkRequest]

     * @throws {RequiredError}
     */
    saveUserProviderLink: (AddUserProviderLinkRequest?: AddUserProviderLinkRequest) => Promise<RequestArgs>;
};
/**
 * MeetingsApi - functional programming interface
 * @export
 */
export declare const MeetingsApiFp: (configuration?: Configuration) => {
    /**
     * A video calling provider must call this endpoint to remove the link between a user and the installed video calling app.
     * @summary Delete the link between a user and the installed video call integration
     * @param {string} id Unique identifier linking a user to the installed integration

     * @throws {RequiredError}
     */
    deleteUserProviderLink(id: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetUserProviderLinkSuccessResponse>>;
    /**
     * A video calling provider must call this endpoint after a user has installed the video calling app so that the new user\'s information is sent.
     * @summary Link a user with the installed video call integration
     * @param {AddUserProviderLinkRequest} [AddUserProviderLinkRequest]

     * @throws {RequiredError}
     */
    saveUserProviderLink(AddUserProviderLinkRequest?: AddUserProviderLinkRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetUserProviderLinkSuccessResponse>>;
};
/**
 * MeetingsApi - factory interface
 * @export
 */
export declare const MeetingsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * A video calling provider must call this endpoint to remove the link between a user and the installed video calling app.
     * @summary Delete the link between a user and the installed video call integration
     * @param {MeetingsApiDeleteUserProviderLinkRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteUserProviderLink(requestParameters: MeetingsApiDeleteUserProviderLinkRequest): Promise<GetUserProviderLinkSuccessResponse>;
    /**
     * A video calling provider must call this endpoint after a user has installed the video calling app so that the new user\'s information is sent.
     * @summary Link a user with the installed video call integration
     * @param {MeetingsApiSaveUserProviderLinkRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    saveUserProviderLink(requestParameters?: MeetingsApiSaveUserProviderLinkRequest): Promise<GetUserProviderLinkSuccessResponse>;
};
/**
 * Request parameters for deleteUserProviderLink operation in MeetingsApi.
 * @export
 * @interface MeetingsApiDeleteUserProviderLinkRequest
 */
export interface MeetingsApiDeleteUserProviderLinkRequest {
    /**
     * Unique identifier linking a user to the installed integration
     * @type {string}
     * @memberof MeetingsApiDeleteUserProviderLink
     */
    readonly id: string;
}
/**
 * Request parameters for saveUserProviderLink operation in MeetingsApi.
 * @export
 * @interface MeetingsApiSaveUserProviderLinkRequest
 */
export interface MeetingsApiSaveUserProviderLinkRequest {
    /**
     *
     * @type {AddUserProviderLinkRequest}
     * @memberof MeetingsApiSaveUserProviderLink
     */
    readonly AddUserProviderLinkRequest?: AddUserProviderLinkRequest;
}
/**
 * MeetingsApi - object-oriented interface
 * @export
 * @class MeetingsApi
 * @extends {BaseAPI}
 */
export declare class MeetingsApi extends BaseAPI {
    /**
     * A video calling provider must call this endpoint to remove the link between a user and the installed video calling app.
     * @summary Delete the link between a user and the installed video call integration
     * @param {MeetingsApiDeleteUserProviderLinkRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof MeetingsApi
     */
    deleteUserProviderLink(requestParameters: MeetingsApiDeleteUserProviderLinkRequest): Promise<GetUserProviderLinkSuccessResponse>;
    /**
     * A video calling provider must call this endpoint after a user has installed the video calling app so that the new user\'s information is sent.
     * @summary Link a user with the installed video call integration
     * @param {MeetingsApiSaveUserProviderLinkRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof MeetingsApi
     */
    saveUserProviderLink(requestParameters?: MeetingsApiSaveUserProviderLinkRequest): Promise<GetUserProviderLinkSuccessResponse>;
}
