/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosInstance } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { AddOrganizationFollowerRequest } from '../models';
import { AddOrganizationFollowerResponse } from '../models';
import { AddOrganizationRequest } from '../models';
import { AddOrganizationResponse } from '../models';
import { DeleteOrganizationFollowerResponse } from '../models';
import { DeleteOrganizationResponse } from '../models';
import { DeleteOrganizationsResponse } from '../models';
import { GetAssociatedActivitiesResponse } from '../models';
import { GetAssociatedDealsResponse } from '../models';
import { GetAssociatedFilesResponse } from '../models';
import { GetAssociatedFollowersResponse } from '../models';
import { GetAssociatedMailMessagesResponse } from '../models';
import { GetAssociatedOrganizationUpdatesResponse } from '../models';
import { GetChangelogResponse } from '../models';
import { GetOrganizationResponse } from '../models';
import { GetOrganizationSearchResponse } from '../models';
import { GetOrganizationsCollection200Response } from '../models';
import { GetOrganizationsResponse } from '../models';
import { GetPermittedUsersResponse1 } from '../models';
import { GetPersonsResponse } from '../models';
import { MergeOrganizationsRequest } from '../models';
import { MergeOrganizationsResponse } from '../models';
import { UpdateOrganizationRequest } from '../models';
import { UpdateOrganizationResponse } from '../models';
/**
 * OrganizationsApi - axios parameter creator
 * @export
 */
export declare const OrganizationsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Adds a new organization. Note that you can supply additional custom fields along with the request that are not described here. These custom fields are different for each Pipedrive account and can be recognized by long hashes as keys. To determine which custom fields exists, fetch the organizationFields and look for `key` values. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-organization\" target=\"_blank\" rel=\"noopener noreferrer\">adding an organization</a>.
     * @summary Add an organization
     * @param {AddOrganizationRequest} [AddOrganizationRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    addOrganization: (AddOrganizationRequest?: AddOrganizationRequest) => Promise<RequestArgs>;
    /**
     * Adds a follower to an organization.
     * @summary Add a follower to an organization
     * @param {number} id The ID of the organization
     * @param {AddOrganizationFollowerRequest} [AddOrganizationFollowerRequest]

     * @throws {RequiredError}
     */
    addOrganizationFollower: (id: number, AddOrganizationFollowerRequest?: AddOrganizationFollowerRequest) => Promise<RequestArgs>;
    /**
     * Marks an organization as deleted. After 30 days, the organization will be permanently deleted.
     * @summary Delete an organization
     * @param {number} id The ID of the organization
     * @deprecated
     * @throws {RequiredError}
     */
    deleteOrganization: (id: number) => Promise<RequestArgs>;
    /**
     * Deletes a follower from an organization. You can retrieve the `follower_id` from the <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizationFollowers\">List followers of an organization</a> endpoint.
     * @summary Delete a follower from an organization
     * @param {number} id The ID of the organization
     * @param {number} follower_id The ID of the relationship between the follower and the organization

     * @throws {RequiredError}
     */
    deleteOrganizationFollower: (id: number, follower_id: number) => Promise<RequestArgs>;
    /**
     * Marks multiple organizations as deleted. After 30 days, the organizations will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#deleteOrganization\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/organizations/{id}</a> instead.
     * @summary Delete multiple organizations in bulk
     * @param {string} ids The comma-separated IDs that will be deleted
     * @deprecated
     * @throws {RequiredError}
     */
    deleteOrganizations: (ids: string) => Promise<RequestArgs>;
    /**
     * Returns the details of an organization. Note that this also returns some additional fields which are not present when asking for all organizations. Also note that custom fields appear as long hashes in the resulting data. These hashes can be mapped against the `key` value of organizationFields.
     * @summary Get details of an organization
     * @param {number} id The ID of the organization
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganization: (id: number) => Promise<RequestArgs>;
    /**
     * Lists activities associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities?org_id={id}</a> instead.
     * @summary List activities associated with an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {0 | 1} [done] Whether the activity is done or not. 0 &#x3D; Not done, 1 &#x3D; Done. If omitted returns both Done and Not done activities.
     * @param {string} [exclude] A comma-separated string of activity IDs to exclude from result
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationActivities: (id: number, start?: number, limit?: number, done?: 0 | 1, exclude?: string) => Promise<RequestArgs>;
    /**
     * Lists updates about field values of an organization.
     * @summary List updates about organization field values
     * @param {number} id The ID of the organization
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getOrganizationChangelog: (id: number, cursor?: string, limit?: number) => Promise<RequestArgs>;
    /**
     * Lists deals associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDeals\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/deals?org_id={id}</a> instead.
     * @summary List deals associated with an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {'open' | 'won' | 'lost' | 'deleted' | 'all_not_deleted'} [status] Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included.
     * @param {string} [sort] The field names and sorting mode separated by a comma (&#x60;field_name_1 ASC&#x60;, &#x60;field_name_2 DESC&#x60;). Only first-level field keys are supported (no nested keys).
     * @param {0 | 1} [only_primary_association] If set, only deals that are directly associated to the organization are fetched. If not set (default), all deals are fetched that are either directly or indirectly related to the organization. Indirect relations include relations through custom, organization-type fields and through persons of the given organization.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationDeals: (id: number, start?: number, limit?: number, status?: 'open' | 'won' | 'lost' | 'deleted' | 'all_not_deleted', sort?: string, only_primary_association?: 0 | 1) => Promise<RequestArgs>;
    /**
     * Lists files associated with an organization.
     * @summary List files attached to an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page. Please note that a maximum value of 100 is allowed.
     * @param {string} [sort] Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;

     * @throws {RequiredError}
     */
    getOrganizationFiles: (id: number, start?: number, limit?: number, sort?: string) => Promise<RequestArgs>;
    /**
     * Lists the followers of an organization.
     * @summary List followers of an organization
     * @param {number} id The ID of the organization

     * @throws {RequiredError}
     */
    getOrganizationFollowers: (id: number) => Promise<RequestArgs>;
    /**
     * Lists mail messages associated with an organization.
     * @summary List mail messages associated with an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getOrganizationMailMessages: (id: number, start?: number, limit?: number) => Promise<RequestArgs>;
    /**
     * Lists persons associated with an organization.<br>If a company uses the [Campaigns product](https://pipedrive.readme.io/docs/campaigns-in-pipedrive-api), then this endpoint will also return the `data.marketing_status` field. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Persons#getPersons\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/persons?org_id={id}</a> instead.
     * @summary List persons of an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationPersons: (id: number, start?: number, limit?: number) => Promise<RequestArgs>;
    /**
     * Lists updates about an organization.
     * @summary List updates about an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {string} [all_changes] Whether to show custom field updates or not. 1 &#x3D; Include custom field changes. If omitted, returns changes without custom field updates.
     * @param {string} [items] A comma-separated string for filtering out item specific updates. (Possible values - activity, plannedActivity, note, file, change, deal, follower, participant, mailMessage, mailMessageWithAttachment, invoice, activityFile, document).

     * @throws {RequiredError}
     */
    getOrganizationUpdates: (id: number, start?: number, limit?: number, all_changes?: string, items?: string) => Promise<RequestArgs>;
    /**
     * List users permitted to access an organization.
     * @summary List permitted users
     * @param {number} id The ID of the organization

     * @throws {RequiredError}
     */
    getOrganizationUsers: (id: number) => Promise<RequestArgs>;
    /**
     * Returns all organizations.
     * @summary Get all organizations
     * @param {number} [user_id] If supplied, only organizations owned by the given user will be returned. However, &#x60;filter_id&#x60; takes precedence over &#x60;user_id&#x60; when both are supplied.
     * @param {number} [filter_id] The ID of the filter to use
     * @param {string} [first_char] If supplied, only organizations whose name starts with the specified letter will be returned (case-insensitive)
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {string} [sort] The field names and sorting mode separated by a comma (&#x60;field_name_1 ASC&#x60;, &#x60;field_name_2 DESC&#x60;). Only first-level field keys are supported (no nested keys).
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizations: (user_id?: number, filter_id?: number, first_char?: string, start?: number, limit?: number, sort?: string) => Promise<RequestArgs>;
    /**
     * Returns all organizations. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizations\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/organizations</a> instead.
     * @summary Get all organizations collection
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [since] The time boundary that points to the start of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {string} [until] The time boundary that points to the end of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {number} [owner_id] If supplied, only organizations owned by the given user will be returned
     * @param {string} [first_char] If supplied, only organizations whose name starts with the specified letter will be returned (case-insensitive)
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationsCollection: (cursor?: string, limit?: number, since?: string, until?: string, owner_id?: number, first_char?: string) => Promise<RequestArgs>;
    /**
     * Merges an organization with another organization. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/merging-two-organizations\" target=\"_blank\" rel=\"noopener noreferrer\">merging two organizations</a>.
     * @summary Merge two organizations
     * @param {number} id The ID of the organization
     * @param {MergeOrganizationsRequest} [MergeOrganizationsRequest]

     * @throws {RequiredError}
     */
    mergeOrganizations: (id: number, MergeOrganizationsRequest?: MergeOrganizationsRequest) => Promise<RequestArgs>;
    /**
     * Searches all organizations by name, address, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope.
     * @summary Search organizations
     * @param {string} term The search term to look for. Minimum 2 characters (or 1 if using &#x60;exact_match&#x60;). Please note that the search term has to be URL encoded.
     * @param {'address' | 'custom_fields' | 'notes' | 'name'} [fields] A comma-separated string array. The fields to perform the search from. Defaults to all of them. Only the following custom field types are searchable: &#x60;address&#x60;, &#x60;varchar&#x60;, &#x60;text&#x60;, &#x60;varchar_auto&#x60;, &#x60;double&#x60;, &#x60;monetary&#x60; and &#x60;phone&#x60;. Read more about searching by custom fields &lt;a href&#x3D;\&quot;https://support.pipedrive.com/en/article/search-finding-what-you-need#searching-by-custom-fields\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener noreferrer\&quot;&gt;here&lt;/a&gt;.
     * @param {boolean} [exact_match] When enabled, only full exact matches against the given term are returned. It is &lt;b&gt;not&lt;/b&gt; case sensitive.
     * @param {number} [start] Pagination start. Note that the pagination is based on main results and does not include related items when using &#x60;search_for_related_items&#x60; parameter.
     * @param {number} [limit] Items shown per page
     * @deprecated
     * @throws {RequiredError}
     */
    searchOrganization: (term: string, fields?: 'address' | 'custom_fields' | 'notes' | 'name', exact_match?: boolean, start?: number, limit?: number) => Promise<RequestArgs>;
    /**
     * Updates the properties of an organization.
     * @summary Update an organization
     * @param {number} id The ID of the organization
     * @param {UpdateOrganizationRequest} [UpdateOrganizationRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    updateOrganization: (id: number, UpdateOrganizationRequest?: UpdateOrganizationRequest) => Promise<RequestArgs>;
};
/**
 * OrganizationsApi - functional programming interface
 * @export
 */
export declare const OrganizationsApiFp: (configuration?: Configuration) => {
    /**
     * Adds a new organization. Note that you can supply additional custom fields along with the request that are not described here. These custom fields are different for each Pipedrive account and can be recognized by long hashes as keys. To determine which custom fields exists, fetch the organizationFields and look for `key` values. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-organization\" target=\"_blank\" rel=\"noopener noreferrer\">adding an organization</a>.
     * @summary Add an organization
     * @param {AddOrganizationRequest} [AddOrganizationRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    addOrganization(AddOrganizationRequest?: AddOrganizationRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddOrganizationResponse>>;
    /**
     * Adds a follower to an organization.
     * @summary Add a follower to an organization
     * @param {number} id The ID of the organization
     * @param {AddOrganizationFollowerRequest} [AddOrganizationFollowerRequest]

     * @throws {RequiredError}
     */
    addOrganizationFollower(id: number, AddOrganizationFollowerRequest?: AddOrganizationFollowerRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddOrganizationFollowerResponse>>;
    /**
     * Marks an organization as deleted. After 30 days, the organization will be permanently deleted.
     * @summary Delete an organization
     * @param {number} id The ID of the organization
     * @deprecated
     * @throws {RequiredError}
     */
    deleteOrganization(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteOrganizationResponse>>;
    /**
     * Deletes a follower from an organization. You can retrieve the `follower_id` from the <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizationFollowers\">List followers of an organization</a> endpoint.
     * @summary Delete a follower from an organization
     * @param {number} id The ID of the organization
     * @param {number} follower_id The ID of the relationship between the follower and the organization

     * @throws {RequiredError}
     */
    deleteOrganizationFollower(id: number, follower_id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteOrganizationFollowerResponse>>;
    /**
     * Marks multiple organizations as deleted. After 30 days, the organizations will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#deleteOrganization\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/organizations/{id}</a> instead.
     * @summary Delete multiple organizations in bulk
     * @param {string} ids The comma-separated IDs that will be deleted
     * @deprecated
     * @throws {RequiredError}
     */
    deleteOrganizations(ids: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteOrganizationsResponse>>;
    /**
     * Returns the details of an organization. Note that this also returns some additional fields which are not present when asking for all organizations. Also note that custom fields appear as long hashes in the resulting data. These hashes can be mapped against the `key` value of organizationFields.
     * @summary Get details of an organization
     * @param {number} id The ID of the organization
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganization(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetOrganizationResponse>>;
    /**
     * Lists activities associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities?org_id={id}</a> instead.
     * @summary List activities associated with an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {0 | 1} [done] Whether the activity is done or not. 0 &#x3D; Not done, 1 &#x3D; Done. If omitted returns both Done and Not done activities.
     * @param {string} [exclude] A comma-separated string of activity IDs to exclude from result
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationActivities(id: number, start?: number, limit?: number, done?: 0 | 1, exclude?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetAssociatedActivitiesResponse>>;
    /**
     * Lists updates about field values of an organization.
     * @summary List updates about organization field values
     * @param {number} id The ID of the organization
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getOrganizationChangelog(id: number, cursor?: string, limit?: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetChangelogResponse>>;
    /**
     * Lists deals associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDeals\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/deals?org_id={id}</a> instead.
     * @summary List deals associated with an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {'open' | 'won' | 'lost' | 'deleted' | 'all_not_deleted'} [status] Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included.
     * @param {string} [sort] The field names and sorting mode separated by a comma (&#x60;field_name_1 ASC&#x60;, &#x60;field_name_2 DESC&#x60;). Only first-level field keys are supported (no nested keys).
     * @param {0 | 1} [only_primary_association] If set, only deals that are directly associated to the organization are fetched. If not set (default), all deals are fetched that are either directly or indirectly related to the organization. Indirect relations include relations through custom, organization-type fields and through persons of the given organization.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationDeals(id: number, start?: number, limit?: number, status?: 'open' | 'won' | 'lost' | 'deleted' | 'all_not_deleted', sort?: string, only_primary_association?: 0 | 1): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetAssociatedDealsResponse>>;
    /**
     * Lists files associated with an organization.
     * @summary List files attached to an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page. Please note that a maximum value of 100 is allowed.
     * @param {string} [sort] Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;

     * @throws {RequiredError}
     */
    getOrganizationFiles(id: number, start?: number, limit?: number, sort?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetAssociatedFilesResponse>>;
    /**
     * Lists the followers of an organization.
     * @summary List followers of an organization
     * @param {number} id The ID of the organization

     * @throws {RequiredError}
     */
    getOrganizationFollowers(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetAssociatedFollowersResponse>>;
    /**
     * Lists mail messages associated with an organization.
     * @summary List mail messages associated with an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getOrganizationMailMessages(id: number, start?: number, limit?: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetAssociatedMailMessagesResponse>>;
    /**
     * Lists persons associated with an organization.<br>If a company uses the [Campaigns product](https://pipedrive.readme.io/docs/campaigns-in-pipedrive-api), then this endpoint will also return the `data.marketing_status` field. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Persons#getPersons\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/persons?org_id={id}</a> instead.
     * @summary List persons of an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationPersons(id: number, start?: number, limit?: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetPersonsResponse>>;
    /**
     * Lists updates about an organization.
     * @summary List updates about an organization
     * @param {number} id The ID of the organization
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {string} [all_changes] Whether to show custom field updates or not. 1 &#x3D; Include custom field changes. If omitted, returns changes without custom field updates.
     * @param {string} [items] A comma-separated string for filtering out item specific updates. (Possible values - activity, plannedActivity, note, file, change, deal, follower, participant, mailMessage, mailMessageWithAttachment, invoice, activityFile, document).

     * @throws {RequiredError}
     */
    getOrganizationUpdates(id: number, start?: number, limit?: number, all_changes?: string, items?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetAssociatedOrganizationUpdatesResponse>>;
    /**
     * List users permitted to access an organization.
     * @summary List permitted users
     * @param {number} id The ID of the organization

     * @throws {RequiredError}
     */
    getOrganizationUsers(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetPermittedUsersResponse1>>;
    /**
     * Returns all organizations.
     * @summary Get all organizations
     * @param {number} [user_id] If supplied, only organizations owned by the given user will be returned. However, &#x60;filter_id&#x60; takes precedence over &#x60;user_id&#x60; when both are supplied.
     * @param {number} [filter_id] The ID of the filter to use
     * @param {string} [first_char] If supplied, only organizations whose name starts with the specified letter will be returned (case-insensitive)
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page
     * @param {string} [sort] The field names and sorting mode separated by a comma (&#x60;field_name_1 ASC&#x60;, &#x60;field_name_2 DESC&#x60;). Only first-level field keys are supported (no nested keys).
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizations(user_id?: number, filter_id?: number, first_char?: string, start?: number, limit?: number, sort?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetOrganizationsResponse>>;
    /**
     * Returns all organizations. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizations\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/organizations</a> instead.
     * @summary Get all organizations collection
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [since] The time boundary that points to the start of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {string} [until] The time boundary that points to the end of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @param {number} [owner_id] If supplied, only organizations owned by the given user will be returned
     * @param {string} [first_char] If supplied, only organizations whose name starts with the specified letter will be returned (case-insensitive)
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationsCollection(cursor?: string, limit?: number, since?: string, until?: string, owner_id?: number, first_char?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetOrganizationsCollection200Response>>;
    /**
     * Merges an organization with another organization. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/merging-two-organizations\" target=\"_blank\" rel=\"noopener noreferrer\">merging two organizations</a>.
     * @summary Merge two organizations
     * @param {number} id The ID of the organization
     * @param {MergeOrganizationsRequest} [MergeOrganizationsRequest]

     * @throws {RequiredError}
     */
    mergeOrganizations(id: number, MergeOrganizationsRequest?: MergeOrganizationsRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<MergeOrganizationsResponse>>;
    /**
     * Searches all organizations by name, address, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope.
     * @summary Search organizations
     * @param {string} term The search term to look for. Minimum 2 characters (or 1 if using &#x60;exact_match&#x60;). Please note that the search term has to be URL encoded.
     * @param {'address' | 'custom_fields' | 'notes' | 'name'} [fields] A comma-separated string array. The fields to perform the search from. Defaults to all of them. Only the following custom field types are searchable: &#x60;address&#x60;, &#x60;varchar&#x60;, &#x60;text&#x60;, &#x60;varchar_auto&#x60;, &#x60;double&#x60;, &#x60;monetary&#x60; and &#x60;phone&#x60;. Read more about searching by custom fields &lt;a href&#x3D;\&quot;https://support.pipedrive.com/en/article/search-finding-what-you-need#searching-by-custom-fields\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener noreferrer\&quot;&gt;here&lt;/a&gt;.
     * @param {boolean} [exact_match] When enabled, only full exact matches against the given term are returned. It is &lt;b&gt;not&lt;/b&gt; case sensitive.
     * @param {number} [start] Pagination start. Note that the pagination is based on main results and does not include related items when using &#x60;search_for_related_items&#x60; parameter.
     * @param {number} [limit] Items shown per page
     * @deprecated
     * @throws {RequiredError}
     */
    searchOrganization(term: string, fields?: 'address' | 'custom_fields' | 'notes' | 'name', exact_match?: boolean, start?: number, limit?: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetOrganizationSearchResponse>>;
    /**
     * Updates the properties of an organization.
     * @summary Update an organization
     * @param {number} id The ID of the organization
     * @param {UpdateOrganizationRequest} [UpdateOrganizationRequest]
     * @deprecated
     * @throws {RequiredError}
     */
    updateOrganization(id: number, UpdateOrganizationRequest?: UpdateOrganizationRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpdateOrganizationResponse>>;
};
/**
 * OrganizationsApi - factory interface
 * @export
 */
export declare const OrganizationsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Adds a new organization. Note that you can supply additional custom fields along with the request that are not described here. These custom fields are different for each Pipedrive account and can be recognized by long hashes as keys. To determine which custom fields exists, fetch the organizationFields and look for `key` values. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-organization\" target=\"_blank\" rel=\"noopener noreferrer\">adding an organization</a>.
     * @summary Add an organization
     * @param {OrganizationsApiAddOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    addOrganization(requestParameters?: OrganizationsApiAddOrganizationRequest): Promise<AddOrganizationResponse>;
    /**
     * Adds a follower to an organization.
     * @summary Add a follower to an organization
     * @param {OrganizationsApiAddOrganizationFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    addOrganizationFollower(requestParameters: OrganizationsApiAddOrganizationFollowerRequest): Promise<AddOrganizationFollowerResponse>;
    /**
     * Marks an organization as deleted. After 30 days, the organization will be permanently deleted.
     * @summary Delete an organization
     * @param {OrganizationsApiDeleteOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    deleteOrganization(requestParameters: OrganizationsApiDeleteOrganizationRequest): Promise<DeleteOrganizationResponse>;
    /**
     * Deletes a follower from an organization. You can retrieve the `follower_id` from the <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizationFollowers\">List followers of an organization</a> endpoint.
     * @summary Delete a follower from an organization
     * @param {OrganizationsApiDeleteOrganizationFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteOrganizationFollower(requestParameters: OrganizationsApiDeleteOrganizationFollowerRequest): Promise<DeleteOrganizationFollowerResponse>;
    /**
     * Marks multiple organizations as deleted. After 30 days, the organizations will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#deleteOrganization\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/organizations/{id}</a> instead.
     * @summary Delete multiple organizations in bulk
     * @param {OrganizationsApiDeleteOrganizationsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    deleteOrganizations(requestParameters: OrganizationsApiDeleteOrganizationsRequest): Promise<DeleteOrganizationsResponse>;
    /**
     * Returns the details of an organization. Note that this also returns some additional fields which are not present when asking for all organizations. Also note that custom fields appear as long hashes in the resulting data. These hashes can be mapped against the `key` value of organizationFields.
     * @summary Get details of an organization
     * @param {OrganizationsApiGetOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganization(requestParameters: OrganizationsApiGetOrganizationRequest): Promise<GetOrganizationResponse>;
    /**
     * Lists activities associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities?org_id={id}</a> instead.
     * @summary List activities associated with an organization
     * @param {OrganizationsApiGetOrganizationActivitiesRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationActivities(requestParameters: OrganizationsApiGetOrganizationActivitiesRequest): Promise<GetAssociatedActivitiesResponse>;
    /**
     * Lists updates about field values of an organization.
     * @summary List updates about organization field values
     * @param {OrganizationsApiGetOrganizationChangelogRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationChangelog(requestParameters: OrganizationsApiGetOrganizationChangelogRequest): Promise<GetChangelogResponse>;
    /**
     * Lists deals associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDeals\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/deals?org_id={id}</a> instead.
     * @summary List deals associated with an organization
     * @param {OrganizationsApiGetOrganizationDealsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationDeals(requestParameters: OrganizationsApiGetOrganizationDealsRequest): Promise<GetAssociatedDealsResponse>;
    /**
     * Lists files associated with an organization.
     * @summary List files attached to an organization
     * @param {OrganizationsApiGetOrganizationFilesRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationFiles(requestParameters: OrganizationsApiGetOrganizationFilesRequest): Promise<GetAssociatedFilesResponse>;
    /**
     * Lists the followers of an organization.
     * @summary List followers of an organization
     * @param {OrganizationsApiGetOrganizationFollowersRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationFollowers(requestParameters: OrganizationsApiGetOrganizationFollowersRequest): Promise<GetAssociatedFollowersResponse>;
    /**
     * Lists mail messages associated with an organization.
     * @summary List mail messages associated with an organization
     * @param {OrganizationsApiGetOrganizationMailMessagesRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationMailMessages(requestParameters: OrganizationsApiGetOrganizationMailMessagesRequest): Promise<GetAssociatedMailMessagesResponse>;
    /**
     * Lists persons associated with an organization.<br>If a company uses the [Campaigns product](https://pipedrive.readme.io/docs/campaigns-in-pipedrive-api), then this endpoint will also return the `data.marketing_status` field. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Persons#getPersons\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/persons?org_id={id}</a> instead.
     * @summary List persons of an organization
     * @param {OrganizationsApiGetOrganizationPersonsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationPersons(requestParameters: OrganizationsApiGetOrganizationPersonsRequest): Promise<GetPersonsResponse>;
    /**
     * Lists updates about an organization.
     * @summary List updates about an organization
     * @param {OrganizationsApiGetOrganizationUpdatesRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationUpdates(requestParameters: OrganizationsApiGetOrganizationUpdatesRequest): Promise<GetAssociatedOrganizationUpdatesResponse>;
    /**
     * List users permitted to access an organization.
     * @summary List permitted users
     * @param {OrganizationsApiGetOrganizationUsersRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationUsers(requestParameters: OrganizationsApiGetOrganizationUsersRequest): Promise<GetPermittedUsersResponse1>;
    /**
     * Returns all organizations.
     * @summary Get all organizations
     * @param {OrganizationsApiGetOrganizationsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizations(requestParameters?: OrganizationsApiGetOrganizationsRequest): Promise<GetOrganizationsResponse>;
    /**
     * Returns all organizations. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizations\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/organizations</a> instead.
     * @summary Get all organizations collection
     * @param {OrganizationsApiGetOrganizationsCollectionRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    getOrganizationsCollection(requestParameters?: OrganizationsApiGetOrganizationsCollectionRequest): Promise<GetOrganizationsCollection200Response>;
    /**
     * Merges an organization with another organization. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/merging-two-organizations\" target=\"_blank\" rel=\"noopener noreferrer\">merging two organizations</a>.
     * @summary Merge two organizations
     * @param {OrganizationsApiMergeOrganizationsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    mergeOrganizations(requestParameters: OrganizationsApiMergeOrganizationsRequest): Promise<MergeOrganizationsResponse>;
    /**
     * Searches all organizations by name, address, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope.
     * @summary Search organizations
     * @param {OrganizationsApiSearchOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    searchOrganization(requestParameters: OrganizationsApiSearchOrganizationRequest): Promise<GetOrganizationSearchResponse>;
    /**
     * Updates the properties of an organization.
     * @summary Update an organization
     * @param {OrganizationsApiUpdateOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     */
    updateOrganization(requestParameters: OrganizationsApiUpdateOrganizationRequest): Promise<UpdateOrganizationResponse>;
};
/**
 * Request parameters for addOrganization operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiAddOrganizationRequest
 */
export interface OrganizationsApiAddOrganizationRequest {
    /**
     *
     * @type {AddOrganizationRequest}
     * @memberof OrganizationsApiAddOrganization
     */
    readonly AddOrganizationRequest?: AddOrganizationRequest;
}
/**
 * Request parameters for addOrganizationFollower operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiAddOrganizationFollowerRequest
 */
export interface OrganizationsApiAddOrganizationFollowerRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiAddOrganizationFollower
     */
    readonly id: number;
    /**
     *
     * @type {AddOrganizationFollowerRequest}
     * @memberof OrganizationsApiAddOrganizationFollower
     */
    readonly AddOrganizationFollowerRequest?: AddOrganizationFollowerRequest;
}
/**
 * Request parameters for deleteOrganization operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiDeleteOrganizationRequest
 */
export interface OrganizationsApiDeleteOrganizationRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiDeleteOrganization
     */
    readonly id: number;
}
/**
 * Request parameters for deleteOrganizationFollower operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiDeleteOrganizationFollowerRequest
 */
export interface OrganizationsApiDeleteOrganizationFollowerRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiDeleteOrganizationFollower
     */
    readonly id: number;
    /**
     * The ID of the relationship between the follower and the organization
     * @type {number}
     * @memberof OrganizationsApiDeleteOrganizationFollower
     */
    readonly follower_id: number;
}
/**
 * Request parameters for deleteOrganizations operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiDeleteOrganizationsRequest
 */
export interface OrganizationsApiDeleteOrganizationsRequest {
    /**
     * The comma-separated IDs that will be deleted
     * @type {string}
     * @memberof OrganizationsApiDeleteOrganizations
     */
    readonly ids: string;
}
/**
 * Request parameters for getOrganization operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationRequest
 */
export interface OrganizationsApiGetOrganizationRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganization
     */
    readonly id: number;
}
/**
 * Request parameters for getOrganizationActivities operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationActivitiesRequest
 */
export interface OrganizationsApiGetOrganizationActivitiesRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationActivities
     */
    readonly id: number;
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationActivities
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationActivities
     */
    readonly limit?: number;
    /**
     * Whether the activity is done or not. 0 &#x3D; Not done, 1 &#x3D; Done. If omitted returns both Done and Not done activities.
     * @type {0 | 1}
     * @memberof OrganizationsApiGetOrganizationActivities
     */
    readonly done?: 0 | 1;
    /**
     * A comma-separated string of activity IDs to exclude from result
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationActivities
     */
    readonly exclude?: string;
}
/**
 * Request parameters for getOrganizationChangelog operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationChangelogRequest
 */
export interface OrganizationsApiGetOrganizationChangelogRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationChangelog
     */
    readonly id: number;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationChangelog
     */
    readonly cursor?: string;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationChangelog
     */
    readonly limit?: number;
}
/**
 * Request parameters for getOrganizationDeals operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationDealsRequest
 */
export interface OrganizationsApiGetOrganizationDealsRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationDeals
     */
    readonly id: number;
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationDeals
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationDeals
     */
    readonly limit?: number;
    /**
     * Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included.
     * @type {'open' | 'won' | 'lost' | 'deleted' | 'all_not_deleted'}
     * @memberof OrganizationsApiGetOrganizationDeals
     */
    readonly status?: 'open' | 'won' | 'lost' | 'deleted' | 'all_not_deleted';
    /**
     * The field names and sorting mode separated by a comma (&#x60;field_name_1 ASC&#x60;, &#x60;field_name_2 DESC&#x60;). Only first-level field keys are supported (no nested keys).
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationDeals
     */
    readonly sort?: string;
    /**
     * If set, only deals that are directly associated to the organization are fetched. If not set (default), all deals are fetched that are either directly or indirectly related to the organization. Indirect relations include relations through custom, organization-type fields and through persons of the given organization.
     * @type {0 | 1}
     * @memberof OrganizationsApiGetOrganizationDeals
     */
    readonly only_primary_association?: 0 | 1;
}
/**
 * Request parameters for getOrganizationFiles operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationFilesRequest
 */
export interface OrganizationsApiGetOrganizationFilesRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationFiles
     */
    readonly id: number;
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationFiles
     */
    readonly start?: number;
    /**
     * Items shown per page. Please note that a maximum value of 100 is allowed.
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationFiles
     */
    readonly limit?: number;
    /**
     * Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationFiles
     */
    readonly sort?: string;
}
/**
 * Request parameters for getOrganizationFollowers operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationFollowersRequest
 */
export interface OrganizationsApiGetOrganizationFollowersRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationFollowers
     */
    readonly id: number;
}
/**
 * Request parameters for getOrganizationMailMessages operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationMailMessagesRequest
 */
export interface OrganizationsApiGetOrganizationMailMessagesRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationMailMessages
     */
    readonly id: number;
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationMailMessages
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationMailMessages
     */
    readonly limit?: number;
}
/**
 * Request parameters for getOrganizationPersons operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationPersonsRequest
 */
export interface OrganizationsApiGetOrganizationPersonsRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationPersons
     */
    readonly id: number;
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationPersons
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationPersons
     */
    readonly limit?: number;
}
/**
 * Request parameters for getOrganizationUpdates operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationUpdatesRequest
 */
export interface OrganizationsApiGetOrganizationUpdatesRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationUpdates
     */
    readonly id: number;
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationUpdates
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationUpdates
     */
    readonly limit?: number;
    /**
     * Whether to show custom field updates or not. 1 &#x3D; Include custom field changes. If omitted, returns changes without custom field updates.
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationUpdates
     */
    readonly all_changes?: string;
    /**
     * A comma-separated string for filtering out item specific updates. (Possible values - activity, plannedActivity, note, file, change, deal, follower, participant, mailMessage, mailMessageWithAttachment, invoice, activityFile, document).
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationUpdates
     */
    readonly items?: string;
}
/**
 * Request parameters for getOrganizationUsers operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationUsersRequest
 */
export interface OrganizationsApiGetOrganizationUsersRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationUsers
     */
    readonly id: number;
}
/**
 * Request parameters for getOrganizations operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationsRequest
 */
export interface OrganizationsApiGetOrganizationsRequest {
    /**
     * If supplied, only organizations owned by the given user will be returned. However, &#x60;filter_id&#x60; takes precedence over &#x60;user_id&#x60; when both are supplied.
     * @type {number}
     * @memberof OrganizationsApiGetOrganizations
     */
    readonly user_id?: number;
    /**
     * The ID of the filter to use
     * @type {number}
     * @memberof OrganizationsApiGetOrganizations
     */
    readonly filter_id?: number;
    /**
     * If supplied, only organizations whose name starts with the specified letter will be returned (case-insensitive)
     * @type {string}
     * @memberof OrganizationsApiGetOrganizations
     */
    readonly first_char?: string;
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationsApiGetOrganizations
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiGetOrganizations
     */
    readonly limit?: number;
    /**
     * The field names and sorting mode separated by a comma (&#x60;field_name_1 ASC&#x60;, &#x60;field_name_2 DESC&#x60;). Only first-level field keys are supported (no nested keys).
     * @type {string}
     * @memberof OrganizationsApiGetOrganizations
     */
    readonly sort?: string;
}
/**
 * Request parameters for getOrganizationsCollection operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiGetOrganizationsCollectionRequest
 */
export interface OrganizationsApiGetOrganizationsCollectionRequest {
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationsCollection
     */
    readonly cursor?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationsCollection
     */
    readonly limit?: number;
    /**
     * The time boundary that points to the start of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationsCollection
     */
    readonly since?: string;
    /**
     * The time boundary that points to the end of the range of data. Datetime in ISO 8601 format. E.g. 2022-11-01 08:55:59. Operates on the &#x60;update_time&#x60; field.
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationsCollection
     */
    readonly until?: string;
    /**
     * If supplied, only organizations owned by the given user will be returned
     * @type {number}
     * @memberof OrganizationsApiGetOrganizationsCollection
     */
    readonly owner_id?: number;
    /**
     * If supplied, only organizations whose name starts with the specified letter will be returned (case-insensitive)
     * @type {string}
     * @memberof OrganizationsApiGetOrganizationsCollection
     */
    readonly first_char?: string;
}
/**
 * Request parameters for mergeOrganizations operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiMergeOrganizationsRequest
 */
export interface OrganizationsApiMergeOrganizationsRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiMergeOrganizations
     */
    readonly id: number;
    /**
     *
     * @type {MergeOrganizationsRequest}
     * @memberof OrganizationsApiMergeOrganizations
     */
    readonly MergeOrganizationsRequest?: MergeOrganizationsRequest;
}
/**
 * Request parameters for searchOrganization operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiSearchOrganizationRequest
 */
export interface OrganizationsApiSearchOrganizationRequest {
    /**
     * The search term to look for. Minimum 2 characters (or 1 if using &#x60;exact_match&#x60;). Please note that the search term has to be URL encoded.
     * @type {string}
     * @memberof OrganizationsApiSearchOrganization
     */
    readonly term: string;
    /**
     * A comma-separated string array. The fields to perform the search from. Defaults to all of them. Only the following custom field types are searchable: &#x60;address&#x60;, &#x60;varchar&#x60;, &#x60;text&#x60;, &#x60;varchar_auto&#x60;, &#x60;double&#x60;, &#x60;monetary&#x60; and &#x60;phone&#x60;. Read more about searching by custom fields &lt;a href&#x3D;\&quot;https://support.pipedrive.com/en/article/search-finding-what-you-need#searching-by-custom-fields\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener noreferrer\&quot;&gt;here&lt;/a&gt;.
     * @type {'address' | 'custom_fields' | 'notes' | 'name'}
     * @memberof OrganizationsApiSearchOrganization
     */
    readonly fields?: 'address' | 'custom_fields' | 'notes' | 'name';
    /**
     * When enabled, only full exact matches against the given term are returned. It is &lt;b&gt;not&lt;/b&gt; case sensitive.
     * @type {boolean}
     * @memberof OrganizationsApiSearchOrganization
     */
    readonly exact_match?: boolean;
    /**
     * Pagination start. Note that the pagination is based on main results and does not include related items when using &#x60;search_for_related_items&#x60; parameter.
     * @type {number}
     * @memberof OrganizationsApiSearchOrganization
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationsApiSearchOrganization
     */
    readonly limit?: number;
}
/**
 * Request parameters for updateOrganization operation in OrganizationsApi.
 * @export
 * @interface OrganizationsApiUpdateOrganizationRequest
 */
export interface OrganizationsApiUpdateOrganizationRequest {
    /**
     * The ID of the organization
     * @type {number}
     * @memberof OrganizationsApiUpdateOrganization
     */
    readonly id: number;
    /**
     *
     * @type {UpdateOrganizationRequest}
     * @memberof OrganizationsApiUpdateOrganization
     */
    readonly UpdateOrganizationRequest?: UpdateOrganizationRequest;
}
/**
 * OrganizationsApi - object-oriented interface
 * @export
 * @class OrganizationsApi
 * @extends {BaseAPI}
 */
export declare class OrganizationsApi extends BaseAPI {
    /**
     * Adds a new organization. Note that you can supply additional custom fields along with the request that are not described here. These custom fields are different for each Pipedrive account and can be recognized by long hashes as keys. To determine which custom fields exists, fetch the organizationFields and look for `key` values. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-an-organization\" target=\"_blank\" rel=\"noopener noreferrer\">adding an organization</a>.
     * @summary Add an organization
     * @param {OrganizationsApiAddOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    addOrganization(requestParameters?: OrganizationsApiAddOrganizationRequest): Promise<AddOrganizationResponse>;
    /**
     * Adds a follower to an organization.
     * @summary Add a follower to an organization
     * @param {OrganizationsApiAddOrganizationFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    addOrganizationFollower(requestParameters: OrganizationsApiAddOrganizationFollowerRequest): Promise<AddOrganizationFollowerResponse>;
    /**
     * Marks an organization as deleted. After 30 days, the organization will be permanently deleted.
     * @summary Delete an organization
     * @param {OrganizationsApiDeleteOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    deleteOrganization(requestParameters: OrganizationsApiDeleteOrganizationRequest): Promise<DeleteOrganizationResponse>;
    /**
     * Deletes a follower from an organization. You can retrieve the `follower_id` from the <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizationFollowers\">List followers of an organization</a> endpoint.
     * @summary Delete a follower from an organization
     * @param {OrganizationsApiDeleteOrganizationFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    deleteOrganizationFollower(requestParameters: OrganizationsApiDeleteOrganizationFollowerRequest): Promise<DeleteOrganizationFollowerResponse>;
    /**
     * Marks multiple organizations as deleted. After 30 days, the organizations will be permanently deleted. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#deleteOrganization\" target=\"_blank\" rel=\"noopener noreferrer\">DELETE /api/v2/organizations/{id}</a> instead.
     * @summary Delete multiple organizations in bulk
     * @param {OrganizationsApiDeleteOrganizationsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    deleteOrganizations(requestParameters: OrganizationsApiDeleteOrganizationsRequest): Promise<DeleteOrganizationsResponse>;
    /**
     * Returns the details of an organization. Note that this also returns some additional fields which are not present when asking for all organizations. Also note that custom fields appear as long hashes in the resulting data. These hashes can be mapped against the `key` value of organizationFields.
     * @summary Get details of an organization
     * @param {OrganizationsApiGetOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganization(requestParameters: OrganizationsApiGetOrganizationRequest): Promise<GetOrganizationResponse>;
    /**
     * Lists activities associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Activities#getActivities\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/activities?org_id={id}</a> instead.
     * @summary List activities associated with an organization
     * @param {OrganizationsApiGetOrganizationActivitiesRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationActivities(requestParameters: OrganizationsApiGetOrganizationActivitiesRequest): Promise<GetAssociatedActivitiesResponse>;
    /**
     * Lists updates about field values of an organization.
     * @summary List updates about organization field values
     * @param {OrganizationsApiGetOrganizationChangelogRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationChangelog(requestParameters: OrganizationsApiGetOrganizationChangelogRequest): Promise<GetChangelogResponse>;
    /**
     * Lists deals associated with an organization. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDeals\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/deals?org_id={id}</a> instead.
     * @summary List deals associated with an organization
     * @param {OrganizationsApiGetOrganizationDealsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationDeals(requestParameters: OrganizationsApiGetOrganizationDealsRequest): Promise<GetAssociatedDealsResponse>;
    /**
     * Lists files associated with an organization.
     * @summary List files attached to an organization
     * @param {OrganizationsApiGetOrganizationFilesRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationFiles(requestParameters: OrganizationsApiGetOrganizationFilesRequest): Promise<GetAssociatedFilesResponse>;
    /**
     * Lists the followers of an organization.
     * @summary List followers of an organization
     * @param {OrganizationsApiGetOrganizationFollowersRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationFollowers(requestParameters: OrganizationsApiGetOrganizationFollowersRequest): Promise<GetAssociatedFollowersResponse>;
    /**
     * Lists mail messages associated with an organization.
     * @summary List mail messages associated with an organization
     * @param {OrganizationsApiGetOrganizationMailMessagesRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationMailMessages(requestParameters: OrganizationsApiGetOrganizationMailMessagesRequest): Promise<GetAssociatedMailMessagesResponse>;
    /**
     * Lists persons associated with an organization.<br>If a company uses the [Campaigns product](https://pipedrive.readme.io/docs/campaigns-in-pipedrive-api), then this endpoint will also return the `data.marketing_status` field. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Persons#getPersons\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/persons?org_id={id}</a> instead.
     * @summary List persons of an organization
     * @param {OrganizationsApiGetOrganizationPersonsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationPersons(requestParameters: OrganizationsApiGetOrganizationPersonsRequest): Promise<GetPersonsResponse>;
    /**
     * Lists updates about an organization.
     * @summary List updates about an organization
     * @param {OrganizationsApiGetOrganizationUpdatesRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationUpdates(requestParameters: OrganizationsApiGetOrganizationUpdatesRequest): Promise<GetAssociatedOrganizationUpdatesResponse>;
    /**
     * List users permitted to access an organization.
     * @summary List permitted users
     * @param {OrganizationsApiGetOrganizationUsersRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationUsers(requestParameters: OrganizationsApiGetOrganizationUsersRequest): Promise<GetPermittedUsersResponse1>;
    /**
     * Returns all organizations.
     * @summary Get all organizations
     * @param {OrganizationsApiGetOrganizationsRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizations(requestParameters?: OrganizationsApiGetOrganizationsRequest): Promise<GetOrganizationsResponse>;
    /**
     * Returns all organizations. Please note that only global admins (those with global permissions) can access this endpoint. Users with regular permissions will receive a 403 response. Read more about global permissions <a href=\"https://support.pipedrive.com/en/article/global-user-management\" target=\"_blank\" rel=\"noopener noreferrer\">here</a>. <br>This endpoint has been deprecated. Please use <a href=\"https://developers.pipedrive.com/docs/api/v1/Organizations#getOrganizations\" target=\"_blank\" rel=\"noopener noreferrer\">GET /api/v2/organizations</a> instead.
     * @summary Get all organizations collection
     * @param {OrganizationsApiGetOrganizationsCollectionRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    getOrganizationsCollection(requestParameters?: OrganizationsApiGetOrganizationsCollectionRequest): Promise<GetOrganizationsCollection200Response>;
    /**
     * Merges an organization with another organization. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/merging-two-organizations\" target=\"_blank\" rel=\"noopener noreferrer\">merging two organizations</a>.
     * @summary Merge two organizations
     * @param {OrganizationsApiMergeOrganizationsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    mergeOrganizations(requestParameters: OrganizationsApiMergeOrganizationsRequest): Promise<MergeOrganizationsResponse>;
    /**
     * Searches all organizations by name, address, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope.
     * @summary Search organizations
     * @param {OrganizationsApiSearchOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    searchOrganization(requestParameters: OrganizationsApiSearchOrganizationRequest): Promise<GetOrganizationSearchResponse>;
    /**
     * Updates the properties of an organization.
     * @summary Update an organization
     * @param {OrganizationsApiUpdateOrganizationRequest} requestParameters Request parameters.
     * @deprecated
     * @throws {RequiredError}
     * @memberof OrganizationsApi
     */
    updateOrganization(requestParameters: OrganizationsApiUpdateOrganizationRequest): Promise<UpdateOrganizationResponse>;
}
