/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosInstance } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { GetRecentsResponse } from '../models';
/**
 * RecentsApi - axios parameter creator
 * @export
 */
export declare const RecentsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Returns data about all recent changes occurred after the given timestamp.
     * @summary Get recents
     * @param {string} since_timestamp The timestamp in UTC. Format: YYYY-MM-DD HH:MM:SS.
     * @param {'activity' | 'activityType' | 'deal' | 'file' | 'filter' | 'note' | 'person' | 'organization' | 'pipeline' | 'product' | 'stage' | 'user'} [items] Multiple selection of item types to include in the query (optional)
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getRecents: (since_timestamp: string, items?: 'activity' | 'activityType' | 'deal' | 'file' | 'filter' | 'note' | 'person' | 'organization' | 'pipeline' | 'product' | 'stage' | 'user', start?: number, limit?: number) => Promise<RequestArgs>;
};
/**
 * RecentsApi - functional programming interface
 * @export
 */
export declare const RecentsApiFp: (configuration?: Configuration) => {
    /**
     * Returns data about all recent changes occurred after the given timestamp.
     * @summary Get recents
     * @param {string} since_timestamp The timestamp in UTC. Format: YYYY-MM-DD HH:MM:SS.
     * @param {'activity' | 'activityType' | 'deal' | 'file' | 'filter' | 'note' | 'person' | 'organization' | 'pipeline' | 'product' | 'stage' | 'user'} [items] Multiple selection of item types to include in the query (optional)
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getRecents(since_timestamp: string, items?: 'activity' | 'activityType' | 'deal' | 'file' | 'filter' | 'note' | 'person' | 'organization' | 'pipeline' | 'product' | 'stage' | 'user', start?: number, limit?: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetRecentsResponse>>;
};
/**
 * RecentsApi - factory interface
 * @export
 */
export declare const RecentsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Returns data about all recent changes occurred after the given timestamp.
     * @summary Get recents
     * @param {RecentsApiGetRecentsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getRecents(requestParameters: RecentsApiGetRecentsRequest): Promise<GetRecentsResponse>;
};
/**
 * Request parameters for getRecents operation in RecentsApi.
 * @export
 * @interface RecentsApiGetRecentsRequest
 */
export interface RecentsApiGetRecentsRequest {
    /**
     * The timestamp in UTC. Format: YYYY-MM-DD HH:MM:SS.
     * @type {string}
     * @memberof RecentsApiGetRecents
     */
    readonly since_timestamp: string;
    /**
     * Multiple selection of item types to include in the query (optional)
     * @type {'activity' | 'activityType' | 'deal' | 'file' | 'filter' | 'note' | 'person' | 'organization' | 'pipeline' | 'product' | 'stage' | 'user'}
     * @memberof RecentsApiGetRecents
     */
    readonly items?: 'activity' | 'activityType' | 'deal' | 'file' | 'filter' | 'note' | 'person' | 'organization' | 'pipeline' | 'product' | 'stage' | 'user';
    /**
     * Pagination start
     * @type {number}
     * @memberof RecentsApiGetRecents
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof RecentsApiGetRecents
     */
    readonly limit?: number;
}
/**
 * RecentsApi - object-oriented interface
 * @export
 * @class RecentsApi
 * @extends {BaseAPI}
 */
export declare class RecentsApi extends BaseAPI {
    /**
     * Returns data about all recent changes occurred after the given timestamp.
     * @summary Get recents
     * @param {RecentsApiGetRecentsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof RecentsApi
     */
    getRecents(requestParameters: RecentsApiGetRecentsRequest): Promise<GetRecentsResponse>;
}
