/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
*
* @export
* @interface AddCallLogRequest
*/
export interface AddCallLogRequest {
    /**
    * Describes the outcome of the call
    * @type {string}
    */
    'outcome': AddCallLogRequestOutcomeConst;
    /**
    * The number called
    * @type {string}
    */
    'to_phone_number': string;
    /**
    * The date and time of the start of the call in UTC. Format: YYYY-MM-DD HH:MM:SS.
    * @type {string}
    */
    'start_time': string;
    /**
    * The date and time of the end of the call in UTC. Format: YYYY-MM-DD HH:MM:SS.
    * @type {string}
    */
    'end_time': string;
    /**
    * The ID of the owner of the call log. Please note that a user without account settings access cannot create call logs for other users.
    * @type {number}
    */
    'user_id'?: number;
    /**
    * If specified, this activity will be converted into a call log, with the information provided. When this field is used, you don\'t need to specify `deal_id`, `person_id` or `org_id`, as they will be ignored in favor of the values already available in the activity. The `activity_id` must refer to a `call` type activity.
    * @type {number}
    */
    'activity_id'?: number;
    /**
    * The name of the activity this call is attached to
    * @type {string}
    */
    'subject'?: string;
    /**
    * The duration of the call in seconds
    * @type {string}
    */
    'duration'?: string;
    /**
    * The number that made the call
    * @type {string}
    */
    'from_phone_number'?: string;
    /**
    * The ID of the person this call is associated with
    * @type {number}
    */
    'person_id'?: number;
    /**
    * The ID of the organization this call is associated with
    * @type {number}
    */
    'org_id'?: number;
    /**
    * The ID of the deal this call is associated with. A call log can be associated with either a deal or a lead, but not both at once.
    * @type {number}
    */
    'deal_id'?: number;
    /**
    * The ID of the lead in the UUID format this call is associated with. A call log can be associated with either a deal or a lead, but not both at once.
    * @type {string}
    */
    'lead_id'?: string;
    /**
    * The note for the call log in HTML format
    * @type {string}
    */
    'note'?: string;
}
export declare const AddCallLogRequestOutcomeConst: {
    readonly connected: "connected";
    readonly no_answer: "no_answer";
    readonly left_message: "left_message";
    readonly left_voicemail: "left_voicemail";
    readonly wrong_number: "wrong_number";
    readonly busy: "busy";
};
export type AddCallLogRequestOutcomeConst = typeof AddCallLogRequestOutcomeConst[keyof typeof AddCallLogRequestOutcomeConst];
