/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
*
* @export
* @interface Field
*/
export interface Field {
    /**
    * The ID of the field. Value is `null` in case of subfields.
    * @type {number}
    */
    'id'?: number;
    /**
    * The key of the field. For custom fields this is generated upon creation.
    * @type {string}
    */
    'key'?: string;
    /**
    * The name of the field
    * @type {string}
    */
    'name'?: string;
    /**
    * The order number of the field
    * @type {number}
    */
    'order_nr'?: number;
    /**
    * The type of the field<table><tr><th>Value</th><th>Description</th></tr><tr><td>`address`</td><td>Address field</td></tr><tr><td>`date`</td><td>Date (format YYYY-MM-DD)</td></tr><tr><td>`daterange`</td><td>Date-range field (has a start date and end date value, both YYYY-MM-DD)</td></tr><tr><td>`double`</td><td>Numeric value</td></tr><tr><td>`enum`</td><td>Options field with a single possible chosen option</td></tr><tr></tr><tr><td>`monetary`</td><td>Monetary field (has a numeric value and a currency value)</td></tr><tr><td>`org`</td><td>Organization field (contains an organization ID which is stored on the same account)</td></tr><tr><td>`people`</td><td>Person field (contains a person ID which is stored on the same account)</td></tr><tr><td>`phone`</td><td>Phone field (up to 255 numbers and/or characters)</td></tr><tr><td>`set`</td><td>Options field with a possibility of having multiple chosen options</td></tr><tr><td>`text`</td><td>Long text (up to 65k characters)</td></tr><tr><td>`time`</td><td>Time field (format HH:MM:SS)</td></tr><tr><td>`timerange`</td><td>Time-range field (has a start time and end time value, both HH:MM:SS)</td></tr><tr><td>`user`</td><td>User field (contains a user ID of another Pipedrive user)</td></tr><tr><td>`varchar`</td><td>Text (up to 255 characters)</td></tr><tr><td>`varchar_auto`</td><td>Autocomplete text (up to 255 characters)</td></tr><tr><td>`visible_to`</td><td>System field that keeps item\'s visibility setting</td></tr></table>
    * @type {string}
    */
    'field_type'?: FieldFieldTypeConst;
    /**
    * The creation time of the field
    * @type {string}
    */
    'add_time'?: string;
    /**
    * The update time of the field
    * @type {string}
    */
    'update_time'?: string;
    /**
    * The ID of the user who created or most recently updated the field, only applicable for custom fields
    * @type {number}
    */
    'last_updated_by_user_id'?: number;
    /**
    * The ID of the user who created the field
    * @type {number}
    */
    'created_by_user_id'?: number;
    /**
    * The active flag of the field
    * @type {boolean}
    */
    'active_flag'?: boolean;
    /**
    * The edit flag of the field
    * @type {boolean}
    */
    'edit_flag'?: boolean;
    /**
    * Not used
    * @type {boolean}
    */
    'index_visible_flag'?: boolean;
    /**
    * Not used
    * @type {boolean}
    */
    'details_visible_flag'?: boolean;
    /**
    * Not used
    * @type {boolean}
    */
    'add_visible_flag'?: boolean;
    /**
    * Not used
    * @type {boolean}
    */
    'important_flag'?: boolean;
    /**
    * Whether or not the field of an item can be edited in bulk
    * @type {boolean}
    */
    'bulk_edit_allowed'?: boolean;
    /**
    * Whether or not items can be searched by this field
    * @type {boolean}
    */
    'searchable_flag'?: boolean;
    /**
    * Whether or not items can be filtered by this field
    * @type {boolean}
    */
    'filtering_allowed'?: boolean;
    /**
    * Whether or not items can be sorted by this field
    * @type {boolean}
    */
    'sortable_flag'?: boolean;
    /**
    * Whether or not the field is mandatory
    * @type {boolean}
    */
    'mandatory_flag'?: boolean;
    /**
    * The options of the field. When there are no options, `null` is returned.
    * @type {Array<object>}
    */
    'options'?: Array<object> | null;
    /**
    * The deleted options of the field. Only present when there is at least 1 deleted option.
    * @type {Array<object>}
    */
    'options_deleted'?: Array<object>;
    /**
    * Whether or not the field is a subfield of another field. Only present if field is subfield.
    * @type {boolean}
    */
    'is_subfield'?: boolean;
    /**
    * The subfields of the field. Only present when the field has subfields.
    * @type {Array<object>}
    */
    'subfields'?: Array<object>;
}
export declare const FieldFieldTypeConst: {
    readonly address: "address";
    readonly date: "date";
    readonly daterange: "daterange";
    readonly double: "double";
    readonly enum: "enum";
    readonly monetary: "monetary";
    readonly org: "org";
    readonly people: "people";
    readonly phone: "phone";
    readonly set: "set";
    readonly text: "text";
    readonly time: "time";
    readonly timerange: "timerange";
    readonly user: "user";
    readonly varchar: "varchar";
    readonly varchar_auto: "varchar_auto";
    readonly visible_to: "visible_to";
};
export type FieldFieldTypeConst = typeof FieldFieldTypeConst[keyof typeof FieldFieldTypeConst];
