/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { LeadValue } from './lead-value';
/**
*
* @export
* @interface Lead
*/
export interface Lead {
    /**
    * The unique ID of the lead in the UUID format
    * @type {string}
    */
    'id': string;
    /**
    * The title of the lead
    * @type {string}
    */
    'title': string;
    /**
    * The ID of the user who owns the lead
    * @type {number}
    */
    'owner_id': number;
    /**
    * The ID of the user who created the lead
    * @type {number}
    */
    'creator_id': number;
    /**
    * The IDs of the lead labels which are associated with the lead
    * @type {Array<string>}
    */
    'label_ids': Array<string>;
    /**
    * The ID of a person which this lead is linked to
    * @type {number}
    */
    'person_id': number | null;
    /**
    * The ID of an organization which this lead is linked to
    * @type {number}
    */
    'organization_id': number | null;
    /**
    * Defines where the lead comes from. Will be `API` if the lead was created through the Public API and will be `Manually created` if the lead was created manually through the UI.
    * @type {string}
    */
    'source_name': string;
    /**
    * The way this Lead was created. `origin` field is set by Pipedrive when Lead is created and cannot be changed.
    * @type {string}
    */
    'origin': string;
    /**
    * The optional ID to further distinguish the origin of the lead - e.g. Which API integration created this Lead.
    * @type {string}
    */
    'origin_id': string | null;
    /**
    * The ID of your Marketing channel this Lead was created from. Recognized Marketing channels can be configured in your <a href=\"https://app.pipedrive.com/settings/fields\" target=\"_blank\" rel=\"noopener noreferrer\">Company settings</a>.
    * @type {number}
    */
    'channel': number | null;
    /**
    * The optional ID to further distinguish the Marketing channel.
    * @type {string}
    */
    'channel_id': string | null;
    /**
    * A flag indicating whether the lead is archived or not
    * @type {boolean}
    */
    'is_archived': boolean;
    /**
    * A flag indicating whether the lead was seen by someone in the Pipedrive UI
    * @type {boolean}
    */
    'was_seen': boolean;
    /**
    *
    * @type {LeadValue}
    */
    'value': LeadValue | null;
    /**
    * The date of when the deal which will be created from the lead is expected to be closed. In ISO 8601 format: YYYY-MM-DD.
    * @type {string}
    */
    'expected_close_date': string | null;
    /**
    * The ID of the next activity associated with the lead
    * @type {number}
    */
    'next_activity_id': number | null;
    /**
    * The date and time of when the lead was created. In ISO 8601 format: YYYY-MM-DDTHH:MM:SSZ.
    * @type {string}
    */
    'add_time': string;
    /**
    * The date and time of when the lead was last updated. In ISO 8601 format: YYYY-MM-DDTHH:MM:SSZ.
    * @type {string}
    */
    'update_time': string;
    /**
    *
    * @type {string}
    */
    'visible_to': LeadVisibleToConst;
    /**
    * The BCC email of the lead
    * @type {string}
    */
    'cc_email': string;
}
export declare const LeadVisibleToConst: {
    readonly _1: "1";
    readonly _3: "3";
    readonly _5: "5";
    readonly _7: "7";
};
export type LeadVisibleToConst = typeof LeadVisibleToConst[keyof typeof LeadVisibleToConst];
