/**
 * Pipedrive API v2
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosInstance } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { AddAInstallmentResponse } from '../models';
import { AddConvertDealToLeadResponse } from '../models';
import { AddConvertLeadToDealResponse } from '../models';
import { AddInstallmentRequestBody } from '../models';
import { ConvertLeadToDealRequest } from '../models';
import { DeleteInstallmentResponse } from '../models';
import { GetConvertResponse1 } from '../models';
import { GetInstallmentsResponse } from '../models';
import { UpdateInstallmentRequestBody } from '../models';
import { UpdateInstallmentResponse } from '../models';
/**
 * BetaApi - axios parameter creator
 * @export
 */
export declare const BetaApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {number} id The ID of the deal to convert

     * @throws {RequiredError}
     */
    convertDealToLead: (id: number) => Promise<RequestArgs>;
    /**
     * Initiates a conversion of a lead to a deal. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. If the conversion is successful, the lead is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Leads#getLeadConversionStatus\">/api/v2/leads/{lead_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a lead to a deal (BETA)
     * @param {string} id The ID of the lead to convert
     * @param {ConvertLeadToDealRequest} [ConvertLeadToDealRequest]

     * @throws {RequiredError}
     */
    convertLeadToDeal: (id: string, ConvertLeadToDealRequest?: ConvertLeadToDealRequest) => Promise<RequestArgs>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment

     * @throws {RequiredError}
     */
    deleteInstallment: (id: number, installment_id: number) => Promise<RequestArgs>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {number} id The ID of a deal
     * @param {string} conversion_id The ID of the conversion

     * @throws {RequiredError}
     */
    getDealConversionStatus: (id: number, conversion_id: string) => Promise<RequestArgs>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {Array<number>} deal_ids An array of integers with the IDs of the deals for which the attached installments will be returned. A maximum of 100 deal IDs can be provided.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'billing_date' | 'deal_id'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;billing_date&#x60;, &#x60;deal_id&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getInstallments: (deal_ids: Array<number>, cursor?: string, limit?: number, sort_by?: 'id' | 'billing_date' | 'deal_id', sort_direction?: 'asc' | 'desc') => Promise<RequestArgs>;
    /**
     * Returns data about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Deal ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Lead conversion status (BETA)
     * @param {string} id The ID of a lead
     * @param {string} conversion_id The ID of the conversion

     * @throws {RequiredError}
     */
    getLeadConversionStatus: (id: string, conversion_id: string) => Promise<RequestArgs>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {number} id The ID of the deal
     * @param {AddInstallmentRequestBody} [AddInstallmentRequestBody]

     * @throws {RequiredError}
     */
    postInstallment: (id: number, AddInstallmentRequestBody?: AddInstallmentRequestBody) => Promise<RequestArgs>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment
     * @param {UpdateInstallmentRequestBody} [UpdateInstallmentRequestBody]

     * @throws {RequiredError}
     */
    updateInstallment: (id: number, installment_id: number, UpdateInstallmentRequestBody?: UpdateInstallmentRequestBody) => Promise<RequestArgs>;
};
/**
 * BetaApi - functional programming interface
 * @export
 */
export declare const BetaApiFp: (configuration?: Configuration) => {
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {number} id The ID of the deal to convert

     * @throws {RequiredError}
     */
    convertDealToLead(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddConvertDealToLeadResponse>>;
    /**
     * Initiates a conversion of a lead to a deal. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. If the conversion is successful, the lead is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Leads#getLeadConversionStatus\">/api/v2/leads/{lead_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a lead to a deal (BETA)
     * @param {string} id The ID of the lead to convert
     * @param {ConvertLeadToDealRequest} [ConvertLeadToDealRequest]

     * @throws {RequiredError}
     */
    convertLeadToDeal(id: string, ConvertLeadToDealRequest?: ConvertLeadToDealRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddConvertLeadToDealResponse>>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment

     * @throws {RequiredError}
     */
    deleteInstallment(id: number, installment_id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteInstallmentResponse>>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {number} id The ID of a deal
     * @param {string} conversion_id The ID of the conversion

     * @throws {RequiredError}
     */
    getDealConversionStatus(id: number, conversion_id: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetConvertResponse1>>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {Array<number>} deal_ids An array of integers with the IDs of the deals for which the attached installments will be returned. A maximum of 100 deal IDs can be provided.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'billing_date' | 'deal_id'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;billing_date&#x60;, &#x60;deal_id&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getInstallments(deal_ids: Array<number>, cursor?: string, limit?: number, sort_by?: 'id' | 'billing_date' | 'deal_id', sort_direction?: 'asc' | 'desc'): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetInstallmentsResponse>>;
    /**
     * Returns data about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Deal ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Lead conversion status (BETA)
     * @param {string} id The ID of a lead
     * @param {string} conversion_id The ID of the conversion

     * @throws {RequiredError}
     */
    getLeadConversionStatus(id: string, conversion_id: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetConvertResponse1>>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {number} id The ID of the deal
     * @param {AddInstallmentRequestBody} [AddInstallmentRequestBody]

     * @throws {RequiredError}
     */
    postInstallment(id: number, AddInstallmentRequestBody?: AddInstallmentRequestBody): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddAInstallmentResponse>>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment
     * @param {UpdateInstallmentRequestBody} [UpdateInstallmentRequestBody]

     * @throws {RequiredError}
     */
    updateInstallment(id: number, installment_id: number, UpdateInstallmentRequestBody?: UpdateInstallmentRequestBody): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpdateInstallmentResponse>>;
};
/**
 * BetaApi - factory interface
 * @export
 */
export declare const BetaApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {BetaApiConvertDealToLeadRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    convertDealToLead(requestParameters: BetaApiConvertDealToLeadRequest): Promise<AddConvertDealToLeadResponse>;
    /**
     * Initiates a conversion of a lead to a deal. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. If the conversion is successful, the lead is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Leads#getLeadConversionStatus\">/api/v2/leads/{lead_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a lead to a deal (BETA)
     * @param {BetaApiConvertLeadToDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    convertLeadToDeal(requestParameters: BetaApiConvertLeadToDealRequest): Promise<AddConvertLeadToDealResponse>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {BetaApiDeleteInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteInstallment(requestParameters: BetaApiDeleteInstallmentRequest): Promise<DeleteInstallmentResponse>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {BetaApiGetDealConversionStatusRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDealConversionStatus(requestParameters: BetaApiGetDealConversionStatusRequest): Promise<GetConvertResponse1>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {BetaApiGetInstallmentsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getInstallments(requestParameters: BetaApiGetInstallmentsRequest): Promise<GetInstallmentsResponse>;
    /**
     * Returns data about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Deal ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Lead conversion status (BETA)
     * @param {BetaApiGetLeadConversionStatusRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getLeadConversionStatus(requestParameters: BetaApiGetLeadConversionStatusRequest): Promise<GetConvertResponse1>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {BetaApiPostInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    postInstallment(requestParameters: BetaApiPostInstallmentRequest): Promise<AddAInstallmentResponse>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {BetaApiUpdateInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    updateInstallment(requestParameters: BetaApiUpdateInstallmentRequest): Promise<UpdateInstallmentResponse>;
};
/**
 * Request parameters for convertDealToLead operation in BetaApi.
 * @export
 * @interface BetaApiConvertDealToLeadRequest
 */
export interface BetaApiConvertDealToLeadRequest {
    /**
     * The ID of the deal to convert
     * @type {number}
     * @memberof BetaApiConvertDealToLead
     */
    readonly id: number;
}
/**
 * Request parameters for convertLeadToDeal operation in BetaApi.
 * @export
 * @interface BetaApiConvertLeadToDealRequest
 */
export interface BetaApiConvertLeadToDealRequest {
    /**
     * The ID of the lead to convert
     * @type {string}
     * @memberof BetaApiConvertLeadToDeal
     */
    readonly id: string;
    /**
     *
     * @type {ConvertLeadToDealRequest}
     * @memberof BetaApiConvertLeadToDeal
     */
    readonly ConvertLeadToDealRequest?: ConvertLeadToDealRequest;
}
/**
 * Request parameters for deleteInstallment operation in BetaApi.
 * @export
 * @interface BetaApiDeleteInstallmentRequest
 */
export interface BetaApiDeleteInstallmentRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof BetaApiDeleteInstallment
     */
    readonly id: number;
    /**
     * The ID of the installment
     * @type {number}
     * @memberof BetaApiDeleteInstallment
     */
    readonly installment_id: number;
}
/**
 * Request parameters for getDealConversionStatus operation in BetaApi.
 * @export
 * @interface BetaApiGetDealConversionStatusRequest
 */
export interface BetaApiGetDealConversionStatusRequest {
    /**
     * The ID of a deal
     * @type {number}
     * @memberof BetaApiGetDealConversionStatus
     */
    readonly id: number;
    /**
     * The ID of the conversion
     * @type {string}
     * @memberof BetaApiGetDealConversionStatus
     */
    readonly conversion_id: string;
}
/**
 * Request parameters for getInstallments operation in BetaApi.
 * @export
 * @interface BetaApiGetInstallmentsRequest
 */
export interface BetaApiGetInstallmentsRequest {
    /**
     * An array of integers with the IDs of the deals for which the attached installments will be returned. A maximum of 100 deal IDs can be provided.
     * @type {Array<number>}
     * @memberof BetaApiGetInstallments
     */
    readonly deal_ids: Array<number>;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof BetaApiGetInstallments
     */
    readonly cursor?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof BetaApiGetInstallments
     */
    readonly limit?: number;
    /**
     * The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;billing_date&#x60;, &#x60;deal_id&#x60;.
     * @type {'id' | 'billing_date' | 'deal_id'}
     * @memberof BetaApiGetInstallments
     */
    readonly sort_by?: 'id' | 'billing_date' | 'deal_id';
    /**
     * The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @type {'asc' | 'desc'}
     * @memberof BetaApiGetInstallments
     */
    readonly sort_direction?: 'asc' | 'desc';
}
/**
 * Request parameters for getLeadConversionStatus operation in BetaApi.
 * @export
 * @interface BetaApiGetLeadConversionStatusRequest
 */
export interface BetaApiGetLeadConversionStatusRequest {
    /**
     * The ID of a lead
     * @type {string}
     * @memberof BetaApiGetLeadConversionStatus
     */
    readonly id: string;
    /**
     * The ID of the conversion
     * @type {string}
     * @memberof BetaApiGetLeadConversionStatus
     */
    readonly conversion_id: string;
}
/**
 * Request parameters for postInstallment operation in BetaApi.
 * @export
 * @interface BetaApiPostInstallmentRequest
 */
export interface BetaApiPostInstallmentRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof BetaApiPostInstallment
     */
    readonly id: number;
    /**
     *
     * @type {AddInstallmentRequestBody}
     * @memberof BetaApiPostInstallment
     */
    readonly AddInstallmentRequestBody?: AddInstallmentRequestBody;
}
/**
 * Request parameters for updateInstallment operation in BetaApi.
 * @export
 * @interface BetaApiUpdateInstallmentRequest
 */
export interface BetaApiUpdateInstallmentRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof BetaApiUpdateInstallment
     */
    readonly id: number;
    /**
     * The ID of the installment
     * @type {number}
     * @memberof BetaApiUpdateInstallment
     */
    readonly installment_id: number;
    /**
     *
     * @type {UpdateInstallmentRequestBody}
     * @memberof BetaApiUpdateInstallment
     */
    readonly UpdateInstallmentRequestBody?: UpdateInstallmentRequestBody;
}
/**
 * BetaApi - object-oriented interface
 * @export
 * @class BetaApi
 * @extends {BaseAPI}
 */
export declare class BetaApi extends BaseAPI {
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {BetaApiConvertDealToLeadRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    convertDealToLead(requestParameters: BetaApiConvertDealToLeadRequest): Promise<AddConvertDealToLeadResponse>;
    /**
     * Initiates a conversion of a lead to a deal. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. If the conversion is successful, the lead is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Leads#getLeadConversionStatus\">/api/v2/leads/{lead_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a lead to a deal (BETA)
     * @param {BetaApiConvertLeadToDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    convertLeadToDeal(requestParameters: BetaApiConvertLeadToDealRequest): Promise<AddConvertLeadToDealResponse>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {BetaApiDeleteInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    deleteInstallment(requestParameters: BetaApiDeleteInstallmentRequest): Promise<DeleteInstallmentResponse>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {BetaApiGetDealConversionStatusRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    getDealConversionStatus(requestParameters: BetaApiGetDealConversionStatusRequest): Promise<GetConvertResponse1>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {BetaApiGetInstallmentsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    getInstallments(requestParameters: BetaApiGetInstallmentsRequest): Promise<GetInstallmentsResponse>;
    /**
     * Returns data about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Deal ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Lead conversion status (BETA)
     * @param {BetaApiGetLeadConversionStatusRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    getLeadConversionStatus(requestParameters: BetaApiGetLeadConversionStatusRequest): Promise<GetConvertResponse1>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {BetaApiPostInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    postInstallment(requestParameters: BetaApiPostInstallmentRequest): Promise<AddAInstallmentResponse>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {BetaApiUpdateInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof BetaApi
     */
    updateInstallment(requestParameters: BetaApiUpdateInstallmentRequest): Promise<UpdateInstallmentResponse>;
}
