/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosInstance } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { CreateFieldRequest } from '../models';
import { DeleteFieldsResponse } from '../models';
import { DeleteResponse } from '../models';
import { GetFieldResponse } from '../models';
import { GetFieldsResponse } from '../models';
import { UpdateFieldRequest } from '../models';
/**
 * OrganizationFieldsApi - axios parameter creator
 * @export
 */
export declare const OrganizationFieldsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Adds a new organization field. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-a-new-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">adding a new custom field</a>.
     * @summary Add a new organization field
     * @param {CreateFieldRequest} [CreateFieldRequest]

     * @throws {RequiredError}
     */
    addOrganizationField: (CreateFieldRequest?: CreateFieldRequest) => Promise<RequestArgs>;
    /**
     * Marks a field as deleted. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/deleting-a-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">deleting a custom field</a>.
     * @summary Delete an organization field
     * @param {number} id The ID of the field

     * @throws {RequiredError}
     */
    deleteOrganizationField: (id: number) => Promise<RequestArgs>;
    /**
     * Marks multiple fields as deleted.
     * @summary Delete multiple organization fields in bulk
     * @param {string} ids The comma-separated field IDs to delete

     * @throws {RequiredError}
     */
    deleteOrganizationFields: (ids: string) => Promise<RequestArgs>;
    /**
     * Returns data about a specific organization field.
     * @summary Get one organization field
     * @param {number} id The ID of the field

     * @throws {RequiredError}
     */
    getOrganizationField: (id: number) => Promise<RequestArgs>;
    /**
     * Returns data about all organization fields.
     * @summary Get all organization fields
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getOrganizationFields: (start?: number, limit?: number) => Promise<RequestArgs>;
    /**
     * Updates an organization field. For more information, see the tutorial for <a href=\" https://pipedrive.readme.io/docs/updating-custom-field-value \" target=\"_blank\" rel=\"noopener noreferrer\">updating custom fields\' values</a>.
     * @summary Update an organization field
     * @param {number} id The ID of the field
     * @param {UpdateFieldRequest} [UpdateFieldRequest]

     * @throws {RequiredError}
     */
    updateOrganizationField: (id: number, UpdateFieldRequest?: UpdateFieldRequest) => Promise<RequestArgs>;
};
/**
 * OrganizationFieldsApi - functional programming interface
 * @export
 */
export declare const OrganizationFieldsApiFp: (configuration?: Configuration) => {
    /**
     * Adds a new organization field. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-a-new-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">adding a new custom field</a>.
     * @summary Add a new organization field
     * @param {CreateFieldRequest} [CreateFieldRequest]

     * @throws {RequiredError}
     */
    addOrganizationField(CreateFieldRequest?: CreateFieldRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetFieldResponse>>;
    /**
     * Marks a field as deleted. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/deleting-a-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">deleting a custom field</a>.
     * @summary Delete an organization field
     * @param {number} id The ID of the field

     * @throws {RequiredError}
     */
    deleteOrganizationField(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteResponse>>;
    /**
     * Marks multiple fields as deleted.
     * @summary Delete multiple organization fields in bulk
     * @param {string} ids The comma-separated field IDs to delete

     * @throws {RequiredError}
     */
    deleteOrganizationFields(ids: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteFieldsResponse>>;
    /**
     * Returns data about a specific organization field.
     * @summary Get one organization field
     * @param {number} id The ID of the field

     * @throws {RequiredError}
     */
    getOrganizationField(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetFieldResponse>>;
    /**
     * Returns data about all organization fields.
     * @summary Get all organization fields
     * @param {number} [start] Pagination start
     * @param {number} [limit] Items shown per page

     * @throws {RequiredError}
     */
    getOrganizationFields(start?: number, limit?: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetFieldsResponse>>;
    /**
     * Updates an organization field. For more information, see the tutorial for <a href=\" https://pipedrive.readme.io/docs/updating-custom-field-value \" target=\"_blank\" rel=\"noopener noreferrer\">updating custom fields\' values</a>.
     * @summary Update an organization field
     * @param {number} id The ID of the field
     * @param {UpdateFieldRequest} [UpdateFieldRequest]

     * @throws {RequiredError}
     */
    updateOrganizationField(id: number, UpdateFieldRequest?: UpdateFieldRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetFieldResponse>>;
};
/**
 * OrganizationFieldsApi - factory interface
 * @export
 */
export declare const OrganizationFieldsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Adds a new organization field. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-a-new-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">adding a new custom field</a>.
     * @summary Add a new organization field
     * @param {OrganizationFieldsApiAddOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    addOrganizationField(requestParameters?: OrganizationFieldsApiAddOrganizationFieldRequest): Promise<GetFieldResponse>;
    /**
     * Marks a field as deleted. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/deleting-a-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">deleting a custom field</a>.
     * @summary Delete an organization field
     * @param {OrganizationFieldsApiDeleteOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteOrganizationField(requestParameters: OrganizationFieldsApiDeleteOrganizationFieldRequest): Promise<DeleteResponse>;
    /**
     * Marks multiple fields as deleted.
     * @summary Delete multiple organization fields in bulk
     * @param {OrganizationFieldsApiDeleteOrganizationFieldsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteOrganizationFields(requestParameters: OrganizationFieldsApiDeleteOrganizationFieldsRequest): Promise<DeleteFieldsResponse>;
    /**
     * Returns data about a specific organization field.
     * @summary Get one organization field
     * @param {OrganizationFieldsApiGetOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationField(requestParameters: OrganizationFieldsApiGetOrganizationFieldRequest): Promise<GetFieldResponse>;
    /**
     * Returns data about all organization fields.
     * @summary Get all organization fields
     * @param {OrganizationFieldsApiGetOrganizationFieldsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getOrganizationFields(requestParameters?: OrganizationFieldsApiGetOrganizationFieldsRequest): Promise<GetFieldsResponse>;
    /**
     * Updates an organization field. For more information, see the tutorial for <a href=\" https://pipedrive.readme.io/docs/updating-custom-field-value \" target=\"_blank\" rel=\"noopener noreferrer\">updating custom fields\' values</a>.
     * @summary Update an organization field
     * @param {OrganizationFieldsApiUpdateOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    updateOrganizationField(requestParameters: OrganizationFieldsApiUpdateOrganizationFieldRequest): Promise<GetFieldResponse>;
};
/**
 * Request parameters for addOrganizationField operation in OrganizationFieldsApi.
 * @export
 * @interface OrganizationFieldsApiAddOrganizationFieldRequest
 */
export interface OrganizationFieldsApiAddOrganizationFieldRequest {
    /**
     *
     * @type {CreateFieldRequest}
     * @memberof OrganizationFieldsApiAddOrganizationField
     */
    readonly CreateFieldRequest?: CreateFieldRequest;
}
/**
 * Request parameters for deleteOrganizationField operation in OrganizationFieldsApi.
 * @export
 * @interface OrganizationFieldsApiDeleteOrganizationFieldRequest
 */
export interface OrganizationFieldsApiDeleteOrganizationFieldRequest {
    /**
     * The ID of the field
     * @type {number}
     * @memberof OrganizationFieldsApiDeleteOrganizationField
     */
    readonly id: number;
}
/**
 * Request parameters for deleteOrganizationFields operation in OrganizationFieldsApi.
 * @export
 * @interface OrganizationFieldsApiDeleteOrganizationFieldsRequest
 */
export interface OrganizationFieldsApiDeleteOrganizationFieldsRequest {
    /**
     * The comma-separated field IDs to delete
     * @type {string}
     * @memberof OrganizationFieldsApiDeleteOrganizationFields
     */
    readonly ids: string;
}
/**
 * Request parameters for getOrganizationField operation in OrganizationFieldsApi.
 * @export
 * @interface OrganizationFieldsApiGetOrganizationFieldRequest
 */
export interface OrganizationFieldsApiGetOrganizationFieldRequest {
    /**
     * The ID of the field
     * @type {number}
     * @memberof OrganizationFieldsApiGetOrganizationField
     */
    readonly id: number;
}
/**
 * Request parameters for getOrganizationFields operation in OrganizationFieldsApi.
 * @export
 * @interface OrganizationFieldsApiGetOrganizationFieldsRequest
 */
export interface OrganizationFieldsApiGetOrganizationFieldsRequest {
    /**
     * Pagination start
     * @type {number}
     * @memberof OrganizationFieldsApiGetOrganizationFields
     */
    readonly start?: number;
    /**
     * Items shown per page
     * @type {number}
     * @memberof OrganizationFieldsApiGetOrganizationFields
     */
    readonly limit?: number;
}
/**
 * Request parameters for updateOrganizationField operation in OrganizationFieldsApi.
 * @export
 * @interface OrganizationFieldsApiUpdateOrganizationFieldRequest
 */
export interface OrganizationFieldsApiUpdateOrganizationFieldRequest {
    /**
     * The ID of the field
     * @type {number}
     * @memberof OrganizationFieldsApiUpdateOrganizationField
     */
    readonly id: number;
    /**
     *
     * @type {UpdateFieldRequest}
     * @memberof OrganizationFieldsApiUpdateOrganizationField
     */
    readonly UpdateFieldRequest?: UpdateFieldRequest;
}
/**
 * OrganizationFieldsApi - object-oriented interface
 * @export
 * @class OrganizationFieldsApi
 * @extends {BaseAPI}
 */
export declare class OrganizationFieldsApi extends BaseAPI {
    /**
     * Adds a new organization field. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/adding-a-new-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">adding a new custom field</a>.
     * @summary Add a new organization field
     * @param {OrganizationFieldsApiAddOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationFieldsApi
     */
    addOrganizationField(requestParameters?: OrganizationFieldsApiAddOrganizationFieldRequest): Promise<GetFieldResponse>;
    /**
     * Marks a field as deleted. For more information, see the tutorial for <a href=\"https://pipedrive.readme.io/docs/deleting-a-custom-field\" target=\"_blank\" rel=\"noopener noreferrer\">deleting a custom field</a>.
     * @summary Delete an organization field
     * @param {OrganizationFieldsApiDeleteOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationFieldsApi
     */
    deleteOrganizationField(requestParameters: OrganizationFieldsApiDeleteOrganizationFieldRequest): Promise<DeleteResponse>;
    /**
     * Marks multiple fields as deleted.
     * @summary Delete multiple organization fields in bulk
     * @param {OrganizationFieldsApiDeleteOrganizationFieldsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationFieldsApi
     */
    deleteOrganizationFields(requestParameters: OrganizationFieldsApiDeleteOrganizationFieldsRequest): Promise<DeleteFieldsResponse>;
    /**
     * Returns data about a specific organization field.
     * @summary Get one organization field
     * @param {OrganizationFieldsApiGetOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationFieldsApi
     */
    getOrganizationField(requestParameters: OrganizationFieldsApiGetOrganizationFieldRequest): Promise<GetFieldResponse>;
    /**
     * Returns data about all organization fields.
     * @summary Get all organization fields
     * @param {OrganizationFieldsApiGetOrganizationFieldsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationFieldsApi
     */
    getOrganizationFields(requestParameters?: OrganizationFieldsApiGetOrganizationFieldsRequest): Promise<GetFieldsResponse>;
    /**
     * Updates an organization field. For more information, see the tutorial for <a href=\" https://pipedrive.readme.io/docs/updating-custom-field-value \" target=\"_blank\" rel=\"noopener noreferrer\">updating custom fields\' values</a>.
     * @summary Update an organization field
     * @param {OrganizationFieldsApiUpdateOrganizationFieldRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof OrganizationFieldsApi
     */
    updateOrganizationField(requestParameters: OrganizationFieldsApiUpdateOrganizationFieldRequest): Promise<GetFieldResponse>;
}
