/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
*
* @export
* @interface AddWebhookRequest
*/
export interface AddWebhookRequest {
    /**
    * A full, valid, publicly accessible URL which determines where to send the notifications. Please note that you cannot use Pipedrive API endpoints as the `subscription_url` and the chosen URL must not redirect to another link.
    * @type {string}
    */
    'subscription_url': string;
    /**
    * The type of action to receive notifications about. Wildcard will match all supported actions.
    * @type {string}
    */
    'event_action': AddWebhookRequestEventActionConst;
    /**
    * The type of object to receive notifications about. Wildcard will match all supported objects.
    * @type {string}
    */
    'event_object': AddWebhookRequestEventObjectConst;
    /**
    * The ID of the user that this webhook will be authorized with. You have the option to use a different user\'s `user_id`. If it is not set, the current user\'s `user_id` will be used. As each webhook event is checked against a user\'s permissions, the webhook will only be sent if the user has access to the specified object(s). If you want to receive notifications for all events, please use a top-level admin user’s `user_id`.
    * @type {number}
    */
    'user_id'?: number;
    /**
    * The HTTP basic auth username of the subscription URL endpoint (if required)
    * @type {string}
    */
    'http_auth_user'?: string;
    /**
    * The HTTP basic auth password of the subscription URL endpoint (if required)
    * @type {string}
    */
    'http_auth_password'?: string;
    /**
    * The webhook\'s version. NB! Webhooks v2 is the default from March 17th, 2025. See <a href=\"https://developers.pipedrive.com/changelog/post/breaking-change-webhooks-v2-will-become-the-new-default-version\" target=\"_blank\" rel=\"noopener noreferrer\">this Changelog post</a> for more details.
    * @type {string}
    */
    'version'?: AddWebhookRequestVersionConst;
}
export declare const AddWebhookRequestEventActionConst: {
    readonly create: "create";
    readonly change: "change";
    readonly delete: "delete";
    readonly Star: "*";
};
export type AddWebhookRequestEventActionConst = typeof AddWebhookRequestEventActionConst[keyof typeof AddWebhookRequestEventActionConst];
export declare const AddWebhookRequestEventObjectConst: {
    readonly activity: "activity";
    readonly deal: "deal";
    readonly lead: "lead";
    readonly note: "note";
    readonly organization: "organization";
    readonly person: "person";
    readonly pipeline: "pipeline";
    readonly product: "product";
    readonly stage: "stage";
    readonly user: "user";
    readonly Star: "*";
};
export type AddWebhookRequestEventObjectConst = typeof AddWebhookRequestEventObjectConst[keyof typeof AddWebhookRequestEventObjectConst];
export declare const AddWebhookRequestVersionConst: {
    readonly _1_0: "1.0";
    readonly _2_0: "2.0";
};
export type AddWebhookRequestVersionConst = typeof AddWebhookRequestVersionConst[keyof typeof AddWebhookRequestVersionConst];
