/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
*
* @export
* @interface BaseDeal
*/
export interface BaseDeal {
    /**
    * The ID of the deal stage
    * @type {number}
    */
    'stage_id'?: number;
    /**
    * The title of the deal
    * @type {string}
    */
    'title'?: string;
    /**
    * The value of the deal
    * @type {number}
    */
    'value'?: number;
    /**
    * The currency associated with the deal
    * @type {string}
    */
    'currency'?: string;
    /**
    * The creation date and time of the deal
    * @type {string}
    */
    'add_time'?: string;
    /**
    * The last updated date and time of the deal
    * @type {string}
    */
    'update_time'?: string;
    /**
    * The last updated date and time of the deal stage
    * @type {string}
    */
    'stage_change_time'?: string;
    /**
    * Whether the deal is active or not
    * @type {boolean}
    */
    'active'?: boolean;
    /**
    * Whether the deal is deleted or not
    * @type {boolean}
    */
    'deleted'?: boolean;
    /**
    * Whether the deal is archived or not
    * @type {boolean}
    */
    'is_archived'?: boolean;
    /**
    * The status of the deal
    * @type {string}
    */
    'status'?: string;
    /**
    * The success probability percentage of the deal
    * @type {number}
    */
    'probability'?: number | null;
    /**
    * The date of the next activity associated with the deal
    * @type {string}
    */
    'next_activity_date'?: string;
    /**
    * The time of the next activity associated with the deal
    * @type {string}
    */
    'next_activity_time'?: string;
    /**
    * The ID of the next activity associated with the deal
    * @type {number}
    */
    'next_activity_id'?: number | null;
    /**
    * The ID of the last activity associated with the deal
    * @type {number}
    */
    'last_activity_id'?: number | null;
    /**
    * The date of the last activity associated with the deal
    * @type {string}
    */
    'last_activity_date'?: string | null;
    /**
    * The reason for losing the deal
    * @type {string}
    */
    'lost_reason'?: string | null;
    /**
    * The visibility of the deal
    * @type {string}
    */
    'visible_to'?: string;
    /**
    * The date and time of closing the deal
    * @type {string}
    */
    'close_time'?: string | null;
    /**
    * The ID of the pipeline associated with the deal
    * @type {number}
    */
    'pipeline_id'?: number;
    /**
    * The date and time of changing the deal status as won
    * @type {string}
    */
    'won_time'?: string;
    /**
    * The date and time of the first time changing the deal status as won
    * @type {string}
    */
    'first_won_time'?: string;
    /**
    * The date and time of changing the deal status as lost
    * @type {string}
    */
    'lost_time'?: string;
    /**
    * The number of products associated with the deal
    * @type {number}
    */
    'products_count'?: number;
    /**
    * The number of files associated with the deal
    * @type {number}
    */
    'files_count'?: number;
    /**
    * The number of notes associated with the deal
    * @type {number}
    */
    'notes_count'?: number;
    /**
    * The number of followers associated with the deal
    * @type {number}
    */
    'followers_count'?: number;
    /**
    * The number of emails associated with the deal
    * @type {number}
    */
    'email_messages_count'?: number;
    /**
    * The number of activities associated with the deal
    * @type {number}
    */
    'activities_count'?: number;
    /**
    * The number of completed activities associated with the deal
    * @type {number}
    */
    'done_activities_count'?: number;
    /**
    * The number of incomplete activities associated with the deal
    * @type {number}
    */
    'undone_activities_count'?: number;
    /**
    * The number of participants associated with the deal
    * @type {number}
    */
    'participants_count'?: number;
    /**
    * The expected close date of the deal
    * @type {string}
    */
    'expected_close_date'?: string;
    /**
    * The date and time of the last incoming email associated with the deal
    * @type {string}
    */
    'last_incoming_mail_time'?: string;
    /**
    * The date and time of the last outgoing email associated with the deal
    * @type {string}
    */
    'last_outgoing_mail_time'?: string;
    /**
    * The label or multiple labels assigned to the deal
    * @type {string}
    */
    'label'?: string;
    /**
    * The order number of the deal stage associated with the deal
    * @type {number}
    */
    'stage_order_nr'?: number;
    /**
    * The name of the person associated with the deal
    * @type {string}
    */
    'person_name'?: string;
    /**
    * The name of the organization associated with the deal
    * @type {string}
    */
    'org_name'?: string;
    /**
    * The subject of the next activity associated with the deal
    * @type {string}
    */
    'next_activity_subject'?: string;
    /**
    * The type of the next activity associated with the deal
    * @type {string}
    */
    'next_activity_type'?: string;
    /**
    * The duration of the next activity associated with the deal
    * @type {string}
    */
    'next_activity_duration'?: string;
    /**
    * The note of the next activity associated with the deal
    * @type {string}
    */
    'next_activity_note'?: string;
    /**
    * The deal value formatted with selected currency. E.g. US$500
    * @type {string}
    */
    'formatted_value'?: string;
    /**
    * Probability times deal value. Probability can either be deal probability or if not set, then stage probability.
    * @type {number}
    */
    'weighted_value'?: number;
    /**
    * The weighted_value formatted with selected currency. E.g. US$500
    * @type {string}
    */
    'formatted_weighted_value'?: string;
    /**
    * The currency associated with the deal
    * @type {string}
    */
    'weighted_value_currency'?: string;
    /**
    * The date and time of changing the deal status as rotten
    * @type {string}
    */
    'rotten_time'?: string | null;
    /**
    * The name of the deal owner
    * @type {string}
    */
    'owner_name'?: string;
    /**
    * The BCC email of the deal
    * @type {string}
    */
    'cc_email'?: string;
    /**
    * If the organization that is associated with the deal is hidden or not
    * @type {boolean}
    */
    'org_hidden'?: boolean;
    /**
    * If the person that is associated with the deal is hidden or not
    * @type {boolean}
    */
    'person_hidden'?: boolean;
    /**
    * The way this Deal was created. `origin` field is set by Pipedrive when Deal is created and cannot be changed.
    * @type {string}
    */
    'origin'?: string;
    /**
    * The optional ID to further distinguish the origin of the deal - e.g. Which API integration created this Deal.
    * @type {string}
    */
    'origin_id'?: string | null;
    /**
    * The ID of your Marketing channel this Deal was created from. Recognized Marketing channels can be configured in your <a href=\"https://app.pipedrive.com/settings/fields\" target=\"_blank\" rel=\"noopener noreferrer\">Company settings</a>.
    * @type {number}
    */
    'channel'?: number | null;
    /**
    * The optional ID to further distinguish the Marketing channel.
    * @type {string}
    */
    'channel_id'?: string | null;
    /**
    * Only available in Advanced and above plans  The Annual Recurring Revenue of the deal  Null if there are no products attached to the deal
    * @type {number}
    */
    'arr'?: number | null;
    /**
    * Only available in Advanced and above plans  The Monthly Recurring Revenue of the deal  Null if there are no products attached to the deal
    * @type {number}
    */
    'mrr'?: number | null;
    /**
    * Only available in Advanced and above plans  The Annual Contract Value of the deal  Null if there are no products attached to the deal
    * @type {number}
    */
    'acv'?: number | null;
    /**
    * Only available in Advanced and above plans  The Currency for Annual Recurring Revenue of the deal  If the `arr` is null, this will also be null
    * @type {string}
    */
    'arr_currency'?: string | null;
    /**
    * Only available in Advanced and above plans  The Currency for Monthly Recurring Revenue of the deal  If the `mrr` is null, this will also be null
    * @type {string}
    */
    'mrr_currency'?: string | null;
    /**
    * Only available in Advanced and above plans  The Currency for Annual Contract Value of the deal  If the `acv` is null, this will also be null
    * @type {string}
    */
    'acv_currency'?: string | null;
}
