/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { BasicPersonRequestEmailInner } from './basic-person-request-email-inner';
import { PersonAllOfPhoneInner } from './person-all-of-phone-inner';
/**
*
* @export
* @interface BasicPersonRequest
*/
export interface BasicPersonRequest {
    /**
    * The ID of the user who will be marked as the owner of this person. When omitted, the authorized user ID will be used.
    * @type {number}
    */
    'owner_id'?: number;
    /**
    * The ID of the organization this person will belong to
    * @type {number}
    */
    'org_id'?: number;
    /**
    * An email address as a string or an array of email objects related to the person. The structure of the array is as follows: `[{ \"value\": \"mail@example.com\", \"primary\": \"true\", \"label\": \"main\" }]`. Please note that only `value` is required.
    * @type {Array<BasicPersonRequestEmailInner>}
    */
    'email'?: Array<BasicPersonRequestEmailInner>;
    /**
    * A phone number supplied as a string or an array of phone objects related to the person. The structure of the array is as follows: `[{ \"value\": \"12345\", \"primary\": \"true\", \"label\": \"mobile\" }]`. Please note that only `value` is required.
    * @type {Array<PersonAllOfPhoneInner>}
    */
    'phone'?: Array<PersonAllOfPhoneInner>;
    /**
    * The label assigned to the person. When the `label` field is updated, the `label_ids` field value will be overwritten by the `label` field value.
    * @type {number}
    */
    'label'?: number;
    /**
    * The IDs of labels assigned to the person. When the `label_ids` field is updated, the `label` field value will be set to the first value of the `label_ids` field.
    * @type {Array<number>}
    */
    'label_ids'?: Array<number>;
    /**
    *
    * @type {string}
    */
    'visible_to'?: BasicPersonRequestVisibleToConst;
    /**
    *
    * @type {string}
    */
    'marketing_status'?: BasicPersonRequestMarketingStatusConst;
    /**
    * The optional creation date & time of the person in UTC. Format: YYYY-MM-DD HH:MM:SS
    * @type {string}
    */
    'add_time'?: string;
}
export declare const BasicPersonRequestVisibleToConst: {
    readonly _1: "1";
    readonly _3: "3";
    readonly _5: "5";
    readonly _7: "7";
};
export type BasicPersonRequestVisibleToConst = typeof BasicPersonRequestVisibleToConst[keyof typeof BasicPersonRequestVisibleToConst];
export declare const BasicPersonRequestMarketingStatusConst: {
    readonly no_consent: "no_consent";
    readonly unsubscribed: "unsubscribed";
    readonly subscribed: "subscribed";
    readonly archived: "archived";
};
export type BasicPersonRequestMarketingStatusConst = typeof BasicPersonRequestMarketingStatusConst[keyof typeof BasicPersonRequestMarketingStatusConst];
