/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
*
* @export
* @interface NewDealParameters
*/
export interface NewDealParameters {
    /**
    * The value of the deal. If omitted, value will be set to 0.
    * @type {string}
    */
    'value'?: string;
    /**
    * The array of the labels IDs.
    * @type {Array<number>}
    */
    'label'?: Array<number>;
    /**
    * The currency of the deal. Accepts a 3-character currency code. If omitted, currency will be set to the default currency of the authorized user.
    * @type {string}
    */
    'currency'?: string;
    /**
    * The ID of the user which will be the owner of the created deal. If not provided, the user making the request will be used.
    * @type {number}
    */
    'user_id'?: number;
    /**
    * The ID of a person which this deal will be linked to. If the person does not exist yet, it needs to be created first. This property is required unless `org_id` is specified.
    * @type {number}
    */
    'person_id'?: number;
    /**
    * The ID of an organization which this deal will be linked to. If the organization does not exist yet, it needs to be created first. This property is required unless `person_id` is specified.
    * @type {number}
    */
    'org_id'?: number;
    /**
    * The ID of the pipeline this deal will be added to. By default, the deal will be added to the first stage of the specified pipeline. Please note that `pipeline_id` and `stage_id` should not be used together as `pipeline_id` will be ignored.
    * @type {number}
    */
    'pipeline_id'?: number;
    /**
    * The ID of the stage this deal will be added to. Please note that a pipeline will be assigned automatically based on the `stage_id`. If omitted, the deal will be placed in the first stage of the default pipeline.
    * @type {number}
    */
    'stage_id'?: number;
    /**
    * Whether the deal is archived or not. If omitted, is_archived will be set to false.
    * @type {boolean}
    */
    'is_archived'?: boolean;
    /**
    * The optional date and time of archiving the deal in UTC. Format: YYYY-MM-DD HH:MM:SS. If omitted and `is_archived` is true, it will be set to the current date and time.
    * @type {string}
    */
    'archive_time'?: string;
    /**
    * open = Open, won = Won, lost = Lost, deleted = Deleted. If omitted, status will be set to open.
    * @type {string}
    */
    'status'?: NewDealParametersStatusConst;
    /**
    * The optional ID to further distinguish the origin of the deal - e.g. Which API integration created this deal. If omitted, `origin_id` will be set to null.
    * @type {string}
    */
    'origin_id'?: string | null;
    /**
    * The ID of Marketing channel this deal was created from. Provided value must be one of the channels configured for your company. You can fetch allowed values with <a href=\"https://developers.pipedrive.com/docs/api/v1/DealFields#getDealField\" target=\"_blank\" rel=\"noopener noreferrer\">GET /v1/dealFields</a>. If omitted, channel will be set to null.
    * @type {number}
    */
    'channel'?: number | null;
    /**
    * The optional ID to further distinguish the Marketing channel. If omitted, `channel_id` will be set to null.
    * @type {string}
    */
    'channel_id'?: string | null;
    /**
    * The optional creation date & time of the deal in UTC. Format: YYYY-MM-DD HH:MM:SS
    * @type {string}
    */
    'add_time'?: string;
}
export declare const NewDealParametersStatusConst: {
    readonly open: "open";
    readonly won: "won";
    readonly lost: "lost";
    readonly deleted: "deleted";
};
export type NewDealParametersStatusConst = typeof NewDealParametersStatusConst[keyof typeof NewDealParametersStatusConst];
