/**
 * Pipedrive API v1
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { LeadValue } from './lead-value';
/**
*
* @export
* @interface UpdateLeadRequest
*/
export interface UpdateLeadRequest {
    /**
    * The name of the lead
    * @type {string}
    */
    'title'?: string | null;
    /**
    * The ID of the user which will be the owner of the created lead. If not provided, the user making the request will be used.
    * @type {number}
    */
    'owner_id'?: number;
    /**
    * The IDs of the lead labels which will be associated with the lead
    * @type {Array<string>}
    */
    'label_ids'?: Array<string>;
    /**
    * The ID of a person which this lead will be linked to. If the person does not exist yet, it needs to be created first. A lead always has to be linked to a person or organization or both.
    * @type {number}
    */
    'person_id'?: number | null;
    /**
    * The ID of an organization which this lead will be linked to. If the organization does not exist yet, it needs to be created first. A lead always has to be linked to a person or organization or both.
    * @type {number}
    */
    'organization_id'?: number | null;
    /**
    * A flag indicating whether the lead is archived or not
    * @type {boolean}
    */
    'is_archived'?: boolean;
    /**
    *
    * @type {LeadValue}
    */
    'value'?: LeadValue | null;
    /**
    * The date of when the deal which will be created from the lead is expected to be closed. In ISO 8601 format: YYYY-MM-DD.
    * @type {string}
    */
    'expected_close_date'?: string | null;
    /**
    *
    * @type {string}
    */
    'visible_to'?: UpdateLeadRequestVisibleToConst;
    /**
    * A flag indicating whether the lead was seen by someone in the Pipedrive UI
    * @type {boolean}
    */
    'was_seen'?: boolean;
    /**
    * The ID of Marketing channel this lead was created from. Provided value must be one of the channels configured for your company which you can fetch with <a href=\"https://developers.pipedrive.com/docs/api/v1/DealFields#getDealField\" target=\"_blank\" rel=\"noopener noreferrer\">GET /v1/dealFields</a>.
    * @type {number}
    */
    'channel'?: number | null;
    /**
    * The optional ID to further distinguish the Marketing channel.
    * @type {string}
    */
    'channel_id'?: string | null;
}
export declare const UpdateLeadRequestVisibleToConst: {
    readonly _1: "1";
    readonly _3: "3";
    readonly _5: "5";
    readonly _7: "7";
};
export type UpdateLeadRequestVisibleToConst = typeof UpdateLeadRequestVisibleToConst[keyof typeof UpdateLeadRequestVisibleToConst];
