/**
 * Pipedrive API v2
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { Configuration } from '../configuration';
import type { AxiosInstance } from 'axios';
import { RequestArgs, BaseAPI } from '../base';
import { AddAInstallmentResponse } from '../models';
import { AddAdditionalDiscountRequestBody } from '../models';
import { AddAdditionalDiscountResponse } from '../models';
import { AddConvertDealToLeadResponse } from '../models';
import { AddDealFollowerRequest } from '../models';
import { AddDealProductRequest } from '../models';
import { AddDealProductResponse } from '../models';
import { AddDealRequest } from '../models';
import { AddFollowerResponse } from '../models';
import { AddInstallmentRequestBody } from '../models';
import { DeleteAdditionalDiscountResponse } from '../models';
import { DeleteDealProductResponse } from '../models';
import { DeleteDealResponse } from '../models';
import { DeleteFollowerResponse } from '../models';
import { DeleteInstallmentResponse } from '../models';
import { GetAdditionalDiscountsResponse } from '../models';
import { GetConvertResponse1 } from '../models';
import { GetDealSearchResponse } from '../models';
import { GetDealsProductsResponse } from '../models';
import { GetDealsResponse } from '../models';
import { GetFollowerChangelogsResponse } from '../models';
import { GetFollowersResponse } from '../models';
import { GetInstallmentsResponse } from '../models';
import { UpdateAdditionalDiscountRequestBody } from '../models';
import { UpdateAdditionalDiscountResponse } from '../models';
import { UpdateDealProductRequest } from '../models';
import { UpdateDealRequest } from '../models';
import { UpdateInstallmentRequestBody } from '../models';
import { UpdateInstallmentResponse } from '../models';
import { UpsertDealResponse } from '../models';
/**
 * DealsApi - axios parameter creator
 * @export
 */
export declare const DealsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     * Adds a new deal.
     * @summary Add a new deal
     * @param {AddDealRequest} [AddDealRequest]

     * @throws {RequiredError}
     */
    addDeal: (AddDealRequest?: AddDealRequest) => Promise<RequestArgs>;
    /**
     * Adds a user as a follower to the deal.
     * @summary Add a follower to a deal
     * @param {number} id The ID of the deal
     * @param {AddDealFollowerRequest} [AddDealFollowerRequest]

     * @throws {RequiredError}
     */
    addDealFollower: (id: number, AddDealFollowerRequest?: AddDealFollowerRequest) => Promise<RequestArgs>;
    /**
     * Adds a product to a deal, creating a new item called a deal-product.
     * @summary Add a product to a deal
     * @param {number} id The ID of the deal
     * @param {AddDealProductRequest} [AddDealProductRequest]

     * @throws {RequiredError}
     */
    addDealProduct: (id: number, AddDealProductRequest?: AddDealProductRequest) => Promise<RequestArgs>;
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {number} id The ID of the deal to convert

     * @throws {RequiredError}
     */
    convertDealToLead: (id: number) => Promise<RequestArgs>;
    /**
     * Removes a discount from a deal, changing the deal value if the deal has one-time products attached.
     * @summary Delete a discount from a deal
     * @param {number} id The ID of the deal
     * @param {number} discount_id The ID of the discount

     * @throws {RequiredError}
     */
    deleteAdditionalDiscount: (id: number, discount_id: number) => Promise<RequestArgs>;
    /**
     * Marks a deal as deleted. After 30 days, the deal will be permanently deleted.
     * @summary Delete a deal
     * @param {number} id The ID of the deal

     * @throws {RequiredError}
     */
    deleteDeal: (id: number) => Promise<RequestArgs>;
    /**
     * Deletes a user follower from the deal.
     * @summary Delete a follower from a deal
     * @param {number} id The ID of the deal
     * @param {number} follower_id The ID of the following user

     * @throws {RequiredError}
     */
    deleteDealFollower: (id: number, follower_id: number) => Promise<RequestArgs>;
    /**
     * Deletes a product attachment from a deal, using the `product_attachment_id`.
     * @summary Delete an attached product from a deal
     * @param {number} id The ID of the deal
     * @param {number} product_attachment_id The product attachment ID

     * @throws {RequiredError}
     */
    deleteDealProduct: (id: number, product_attachment_id: number) => Promise<RequestArgs>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment

     * @throws {RequiredError}
     */
    deleteInstallment: (id: number, installment_id: number) => Promise<RequestArgs>;
    /**
     * Lists discounts attached to a deal.
     * @summary List discounts added to a deal
     * @param {number} id The ID of the deal

     * @throws {RequiredError}
     */
    getAdditionalDiscounts: (id: number) => Promise<RequestArgs>;
    /**
     * Returns data about all archived deals.
     * @summary Get all archived deals
     * @param {number} [filter_id] If supplied, only deals matching the specified filter are returned
     * @param {string} [ids] Optional comma separated string array of up to 100 entity ids to fetch. If filter_id is provided, this is ignored. If any of the requested entities do not exist or are not visible, they are not included in the response.
     * @param {number} [owner_id] If supplied, only deals owned by the specified user are returned. If filter_id is provided, this is ignored.
     * @param {number} [person_id] If supplied, only deals linked to the specified person are returned. If filter_id is provided, this is ignored.
     * @param {number} [org_id] If supplied, only deals linked to the specified organization are returned. If filter_id is provided, this is ignored.
     * @param {number} [pipeline_id] If supplied, only deals in the specified pipeline are returned. If filter_id is provided, this is ignored.
     * @param {number} [stage_id] If supplied, only deals in the specified stage are returned. If filter_id is provided, this is ignored.
     * @param {'open' | 'won' | 'lost' | 'deleted'} [status] Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included. Multiple statuses can be included as a comma separated array. If filter_id is provided, this is ignored.
     * @param {string} [updated_since] If set, only deals with an &#x60;update_time&#x60; later than or equal to this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {string} [updated_until] If set, only deals with an &#x60;update_time&#x60; earlier than this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {'id' | 'update_time' | 'add_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;, &#x60;add_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @param {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'} [include_fields] Optional comma separated string array of additional fields to include
     * @param {string} [custom_fields] Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getArchivedDeals: (filter_id?: number, ids?: string, owner_id?: number, person_id?: number, org_id?: number, pipeline_id?: number, stage_id?: number, status?: 'open' | 'won' | 'lost' | 'deleted', updated_since?: string, updated_until?: string, sort_by?: 'id' | 'update_time' | 'add_time', sort_direction?: 'asc' | 'desc', include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email', custom_fields?: string, limit?: number, cursor?: string) => Promise<RequestArgs>;
    /**
     * Returns the details of a specific deal.
     * @summary Get details of a deal
     * @param {number} id The ID of the deal
     * @param {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'} [include_fields] Optional comma separated string array of additional fields to include
     * @param {string} [custom_fields] Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.

     * @throws {RequiredError}
     */
    getDeal: (id: number, include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email', custom_fields?: string) => Promise<RequestArgs>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {number} id The ID of a deal
     * @param {string} conversion_id The ID of the conversion

     * @throws {RequiredError}
     */
    getDealConversionStatus: (id: number, conversion_id: string) => Promise<RequestArgs>;
    /**
     * Lists users who are following the deal.
     * @summary List followers of a deal
     * @param {number} id The ID of the deal
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getDealFollowers: (id: number, limit?: number, cursor?: string) => Promise<RequestArgs>;
    /**
     * Lists changelogs about users have followed the deal.
     * @summary List followers changelog of a deal
     * @param {number} id The ID of the deal
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getDealFollowersChangelog: (id: number, limit?: number, cursor?: string) => Promise<RequestArgs>;
    /**
     * Lists products attached to a deal.
     * @summary List products attached to a deal
     * @param {number} id The ID of the deal
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'add_time' | 'update_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;add_time&#x60;, &#x60;update_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getDealProducts: (id: number, cursor?: string, limit?: number, sort_by?: 'id' | 'add_time' | 'update_time', sort_direction?: 'asc' | 'desc') => Promise<RequestArgs>;
    /**
     * Returns data about all not archived deals.
     * @summary Get all deals
     * @param {number} [filter_id] If supplied, only deals matching the specified filter are returned
     * @param {string} [ids] Optional comma separated string array of up to 100 entity ids to fetch. If filter_id is provided, this is ignored. If any of the requested entities do not exist or are not visible, they are not included in the response.
     * @param {number} [owner_id] If supplied, only deals owned by the specified user are returned. If filter_id is provided, this is ignored.
     * @param {number} [person_id] If supplied, only deals linked to the specified person are returned. If filter_id is provided, this is ignored.
     * @param {number} [org_id] If supplied, only deals linked to the specified organization are returned. If filter_id is provided, this is ignored.
     * @param {number} [pipeline_id] If supplied, only deals in the specified pipeline are returned. If filter_id is provided, this is ignored.
     * @param {number} [stage_id] If supplied, only deals in the specified stage are returned. If filter_id is provided, this is ignored.
     * @param {'open' | 'won' | 'lost' | 'deleted'} [status] Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included. Multiple statuses can be included as a comma separated array. If filter_id is provided, this is ignored.
     * @param {string} [updated_since] If set, only deals with an &#x60;update_time&#x60; later than or equal to this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {string} [updated_until] If set, only deals with an &#x60;update_time&#x60; earlier than this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {'id' | 'update_time' | 'add_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;, &#x60;add_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @param {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'} [include_fields] Optional comma separated string array of additional fields to include
     * @param {string} [custom_fields] Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getDeals: (filter_id?: number, ids?: string, owner_id?: number, person_id?: number, org_id?: number, pipeline_id?: number, stage_id?: number, status?: 'open' | 'won' | 'lost' | 'deleted', updated_since?: string, updated_until?: string, sort_by?: 'id' | 'update_time' | 'add_time', sort_direction?: 'asc' | 'desc', include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email', custom_fields?: string, limit?: number, cursor?: string) => Promise<RequestArgs>;
    /**
     * Returns data about products attached to deals
     * @summary Get deal products of several deals
     * @param {Array<number>} deal_ids An array of integers with the IDs of the deals for which the attached products will be returned. A maximum of 100 deal IDs can be provided.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'deal_id' | 'add_time' | 'update_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;deal_id&#x60;, &#x60;add_time&#x60;, &#x60;update_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getDealsProducts: (deal_ids: Array<number>, cursor?: string, limit?: number, sort_by?: 'id' | 'deal_id' | 'add_time' | 'update_time', sort_direction?: 'asc' | 'desc') => Promise<RequestArgs>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {Array<number>} deal_ids An array of integers with the IDs of the deals for which the attached installments will be returned. A maximum of 100 deal IDs can be provided.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'billing_date' | 'deal_id'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;billing_date&#x60;, &#x60;deal_id&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getInstallments: (deal_ids: Array<number>, cursor?: string, limit?: number, sort_by?: 'id' | 'billing_date' | 'deal_id', sort_direction?: 'asc' | 'desc') => Promise<RequestArgs>;
    /**
     * Adds a discount to a deal changing, the deal value if the deal has one-time products attached.
     * @summary Add a discount to a deal
     * @param {number} id The ID of the deal
     * @param {AddAdditionalDiscountRequestBody} [AddAdditionalDiscountRequestBody]

     * @throws {RequiredError}
     */
    postAdditionalDiscount: (id: number, AddAdditionalDiscountRequestBody?: AddAdditionalDiscountRequestBody) => Promise<RequestArgs>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {number} id The ID of the deal
     * @param {AddInstallmentRequestBody} [AddInstallmentRequestBody]

     * @throws {RequiredError}
     */
    postInstallment: (id: number, AddInstallmentRequestBody?: AddInstallmentRequestBody) => Promise<RequestArgs>;
    /**
     * Searches all deals by title, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope. Found deals can be filtered by the person ID and the organization ID.
     * @summary Search deals
     * @param {string} term The search term to look for. Minimum 2 characters (or 1 if using &#x60;exact_match&#x60;). Please note that the search term has to be URL encoded.
     * @param {'custom_fields' | 'notes' | 'title'} [fields] A comma-separated string array. The fields to perform the search from. Defaults to all of them. Only the following custom field types are searchable: &#x60;address&#x60;, &#x60;varchar&#x60;, &#x60;text&#x60;, &#x60;varchar_auto&#x60;, &#x60;double&#x60;, &#x60;monetary&#x60; and &#x60;phone&#x60;. Read more about searching by custom fields &lt;a href&#x3D;\&quot;https://support.pipedrive.com/en/article/search-finding-what-you-need#searching-by-custom-fields\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener noreferrer\&quot;&gt;here&lt;/a&gt;.
     * @param {boolean} [exact_match] When enabled, only full exact matches against the given term are returned. It is &lt;b&gt;not&lt;/b&gt; case sensitive.
     * @param {number} [person_id] Will filter deals by the provided person ID. The upper limit of found deals associated with the person is 2000.
     * @param {number} [organization_id] Will filter deals by the provided organization ID. The upper limit of found deals associated with the organization is 2000.
     * @param {'open' | 'won' | 'lost'} [status] Will filter deals by the provided specific status. open &#x3D; Open, won &#x3D; Won, lost &#x3D; Lost. The upper limit of found deals associated with the status is 2000.
     * @param {'deal.cc_email'} [include_fields] Supports including optional fields in the results which are not provided by default
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    searchDeals: (term: string, fields?: 'custom_fields' | 'notes' | 'title', exact_match?: boolean, person_id?: number, organization_id?: number, status?: 'open' | 'won' | 'lost', include_fields?: 'deal.cc_email', limit?: number, cursor?: string) => Promise<RequestArgs>;
    /**
     * Edits a discount added to a deal, changing the deal value if the deal has one-time products attached.
     * @summary Update a discount added to a deal
     * @param {number} id The ID of the deal
     * @param {number} discount_id The ID of the discount
     * @param {UpdateAdditionalDiscountRequestBody} [UpdateAdditionalDiscountRequestBody]

     * @throws {RequiredError}
     */
    updateAdditionalDiscount: (id: number, discount_id: number, UpdateAdditionalDiscountRequestBody?: UpdateAdditionalDiscountRequestBody) => Promise<RequestArgs>;
    /**
     * Updates the properties of a deal.
     * @summary Update a deal
     * @param {number} id The ID of the deal
     * @param {UpdateDealRequest} [UpdateDealRequest]

     * @throws {RequiredError}
     */
    updateDeal: (id: number, UpdateDealRequest?: UpdateDealRequest) => Promise<RequestArgs>;
    /**
     * Updates the details of the product that has been attached to a deal.
     * @summary Update the product attached to a deal
     * @param {number} id The ID of the deal
     * @param {number} product_attachment_id The ID of the deal-product (the ID of the product attached to the deal)
     * @param {UpdateDealProductRequest} [UpdateDealProductRequest]

     * @throws {RequiredError}
     */
    updateDealProduct: (id: number, product_attachment_id: number, UpdateDealProductRequest?: UpdateDealProductRequest) => Promise<RequestArgs>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment
     * @param {UpdateInstallmentRequestBody} [UpdateInstallmentRequestBody]

     * @throws {RequiredError}
     */
    updateInstallment: (id: number, installment_id: number, UpdateInstallmentRequestBody?: UpdateInstallmentRequestBody) => Promise<RequestArgs>;
};
/**
 * DealsApi - functional programming interface
 * @export
 */
export declare const DealsApiFp: (configuration?: Configuration) => {
    /**
     * Adds a new deal.
     * @summary Add a new deal
     * @param {AddDealRequest} [AddDealRequest]

     * @throws {RequiredError}
     */
    addDeal(AddDealRequest?: AddDealRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpsertDealResponse>>;
    /**
     * Adds a user as a follower to the deal.
     * @summary Add a follower to a deal
     * @param {number} id The ID of the deal
     * @param {AddDealFollowerRequest} [AddDealFollowerRequest]

     * @throws {RequiredError}
     */
    addDealFollower(id: number, AddDealFollowerRequest?: AddDealFollowerRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddFollowerResponse>>;
    /**
     * Adds a product to a deal, creating a new item called a deal-product.
     * @summary Add a product to a deal
     * @param {number} id The ID of the deal
     * @param {AddDealProductRequest} [AddDealProductRequest]

     * @throws {RequiredError}
     */
    addDealProduct(id: number, AddDealProductRequest?: AddDealProductRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddDealProductResponse>>;
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {number} id The ID of the deal to convert

     * @throws {RequiredError}
     */
    convertDealToLead(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddConvertDealToLeadResponse>>;
    /**
     * Removes a discount from a deal, changing the deal value if the deal has one-time products attached.
     * @summary Delete a discount from a deal
     * @param {number} id The ID of the deal
     * @param {number} discount_id The ID of the discount

     * @throws {RequiredError}
     */
    deleteAdditionalDiscount(id: number, discount_id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteAdditionalDiscountResponse>>;
    /**
     * Marks a deal as deleted. After 30 days, the deal will be permanently deleted.
     * @summary Delete a deal
     * @param {number} id The ID of the deal

     * @throws {RequiredError}
     */
    deleteDeal(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteDealResponse>>;
    /**
     * Deletes a user follower from the deal.
     * @summary Delete a follower from a deal
     * @param {number} id The ID of the deal
     * @param {number} follower_id The ID of the following user

     * @throws {RequiredError}
     */
    deleteDealFollower(id: number, follower_id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteFollowerResponse>>;
    /**
     * Deletes a product attachment from a deal, using the `product_attachment_id`.
     * @summary Delete an attached product from a deal
     * @param {number} id The ID of the deal
     * @param {number} product_attachment_id The product attachment ID

     * @throws {RequiredError}
     */
    deleteDealProduct(id: number, product_attachment_id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteDealProductResponse>>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment

     * @throws {RequiredError}
     */
    deleteInstallment(id: number, installment_id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<DeleteInstallmentResponse>>;
    /**
     * Lists discounts attached to a deal.
     * @summary List discounts added to a deal
     * @param {number} id The ID of the deal

     * @throws {RequiredError}
     */
    getAdditionalDiscounts(id: number): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetAdditionalDiscountsResponse>>;
    /**
     * Returns data about all archived deals.
     * @summary Get all archived deals
     * @param {number} [filter_id] If supplied, only deals matching the specified filter are returned
     * @param {string} [ids] Optional comma separated string array of up to 100 entity ids to fetch. If filter_id is provided, this is ignored. If any of the requested entities do not exist or are not visible, they are not included in the response.
     * @param {number} [owner_id] If supplied, only deals owned by the specified user are returned. If filter_id is provided, this is ignored.
     * @param {number} [person_id] If supplied, only deals linked to the specified person are returned. If filter_id is provided, this is ignored.
     * @param {number} [org_id] If supplied, only deals linked to the specified organization are returned. If filter_id is provided, this is ignored.
     * @param {number} [pipeline_id] If supplied, only deals in the specified pipeline are returned. If filter_id is provided, this is ignored.
     * @param {number} [stage_id] If supplied, only deals in the specified stage are returned. If filter_id is provided, this is ignored.
     * @param {'open' | 'won' | 'lost' | 'deleted'} [status] Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included. Multiple statuses can be included as a comma separated array. If filter_id is provided, this is ignored.
     * @param {string} [updated_since] If set, only deals with an &#x60;update_time&#x60; later than or equal to this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {string} [updated_until] If set, only deals with an &#x60;update_time&#x60; earlier than this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {'id' | 'update_time' | 'add_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;, &#x60;add_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @param {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'} [include_fields] Optional comma separated string array of additional fields to include
     * @param {string} [custom_fields] Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getArchivedDeals(filter_id?: number, ids?: string, owner_id?: number, person_id?: number, org_id?: number, pipeline_id?: number, stage_id?: number, status?: 'open' | 'won' | 'lost' | 'deleted', updated_since?: string, updated_until?: string, sort_by?: 'id' | 'update_time' | 'add_time', sort_direction?: 'asc' | 'desc', include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email', custom_fields?: string, limit?: number, cursor?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetDealsResponse>>;
    /**
     * Returns the details of a specific deal.
     * @summary Get details of a deal
     * @param {number} id The ID of the deal
     * @param {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'} [include_fields] Optional comma separated string array of additional fields to include
     * @param {string} [custom_fields] Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.

     * @throws {RequiredError}
     */
    getDeal(id: number, include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email', custom_fields?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpsertDealResponse>>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {number} id The ID of a deal
     * @param {string} conversion_id The ID of the conversion

     * @throws {RequiredError}
     */
    getDealConversionStatus(id: number, conversion_id: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetConvertResponse1>>;
    /**
     * Lists users who are following the deal.
     * @summary List followers of a deal
     * @param {number} id The ID of the deal
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getDealFollowers(id: number, limit?: number, cursor?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetFollowersResponse>>;
    /**
     * Lists changelogs about users have followed the deal.
     * @summary List followers changelog of a deal
     * @param {number} id The ID of the deal
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getDealFollowersChangelog(id: number, limit?: number, cursor?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetFollowerChangelogsResponse>>;
    /**
     * Lists products attached to a deal.
     * @summary List products attached to a deal
     * @param {number} id The ID of the deal
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'add_time' | 'update_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;add_time&#x60;, &#x60;update_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getDealProducts(id: number, cursor?: string, limit?: number, sort_by?: 'id' | 'add_time' | 'update_time', sort_direction?: 'asc' | 'desc'): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetDealsProductsResponse>>;
    /**
     * Returns data about all not archived deals.
     * @summary Get all deals
     * @param {number} [filter_id] If supplied, only deals matching the specified filter are returned
     * @param {string} [ids] Optional comma separated string array of up to 100 entity ids to fetch. If filter_id is provided, this is ignored. If any of the requested entities do not exist or are not visible, they are not included in the response.
     * @param {number} [owner_id] If supplied, only deals owned by the specified user are returned. If filter_id is provided, this is ignored.
     * @param {number} [person_id] If supplied, only deals linked to the specified person are returned. If filter_id is provided, this is ignored.
     * @param {number} [org_id] If supplied, only deals linked to the specified organization are returned. If filter_id is provided, this is ignored.
     * @param {number} [pipeline_id] If supplied, only deals in the specified pipeline are returned. If filter_id is provided, this is ignored.
     * @param {number} [stage_id] If supplied, only deals in the specified stage are returned. If filter_id is provided, this is ignored.
     * @param {'open' | 'won' | 'lost' | 'deleted'} [status] Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included. Multiple statuses can be included as a comma separated array. If filter_id is provided, this is ignored.
     * @param {string} [updated_since] If set, only deals with an &#x60;update_time&#x60; later than or equal to this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {string} [updated_until] If set, only deals with an &#x60;update_time&#x60; earlier than this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @param {'id' | 'update_time' | 'add_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;, &#x60;add_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @param {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'} [include_fields] Optional comma separated string array of additional fields to include
     * @param {string} [custom_fields] Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    getDeals(filter_id?: number, ids?: string, owner_id?: number, person_id?: number, org_id?: number, pipeline_id?: number, stage_id?: number, status?: 'open' | 'won' | 'lost' | 'deleted', updated_since?: string, updated_until?: string, sort_by?: 'id' | 'update_time' | 'add_time', sort_direction?: 'asc' | 'desc', include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email', custom_fields?: string, limit?: number, cursor?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetDealsResponse>>;
    /**
     * Returns data about products attached to deals
     * @summary Get deal products of several deals
     * @param {Array<number>} deal_ids An array of integers with the IDs of the deals for which the attached products will be returned. A maximum of 100 deal IDs can be provided.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'deal_id' | 'add_time' | 'update_time'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;deal_id&#x60;, &#x60;add_time&#x60;, &#x60;update_time&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getDealsProducts(deal_ids: Array<number>, cursor?: string, limit?: number, sort_by?: 'id' | 'deal_id' | 'add_time' | 'update_time', sort_direction?: 'asc' | 'desc'): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetDealsProductsResponse>>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {Array<number>} deal_ids An array of integers with the IDs of the deals for which the attached installments will be returned. A maximum of 100 deal IDs can be provided.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {'id' | 'billing_date' | 'deal_id'} [sort_by] The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;billing_date&#x60;, &#x60;deal_id&#x60;.
     * @param {'asc' | 'desc'} [sort_direction] The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.

     * @throws {RequiredError}
     */
    getInstallments(deal_ids: Array<number>, cursor?: string, limit?: number, sort_by?: 'id' | 'billing_date' | 'deal_id', sort_direction?: 'asc' | 'desc'): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetInstallmentsResponse>>;
    /**
     * Adds a discount to a deal changing, the deal value if the deal has one-time products attached.
     * @summary Add a discount to a deal
     * @param {number} id The ID of the deal
     * @param {AddAdditionalDiscountRequestBody} [AddAdditionalDiscountRequestBody]

     * @throws {RequiredError}
     */
    postAdditionalDiscount(id: number, AddAdditionalDiscountRequestBody?: AddAdditionalDiscountRequestBody): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddAdditionalDiscountResponse>>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {number} id The ID of the deal
     * @param {AddInstallmentRequestBody} [AddInstallmentRequestBody]

     * @throws {RequiredError}
     */
    postInstallment(id: number, AddInstallmentRequestBody?: AddInstallmentRequestBody): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddAInstallmentResponse>>;
    /**
     * Searches all deals by title, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope. Found deals can be filtered by the person ID and the organization ID.
     * @summary Search deals
     * @param {string} term The search term to look for. Minimum 2 characters (or 1 if using &#x60;exact_match&#x60;). Please note that the search term has to be URL encoded.
     * @param {'custom_fields' | 'notes' | 'title'} [fields] A comma-separated string array. The fields to perform the search from. Defaults to all of them. Only the following custom field types are searchable: &#x60;address&#x60;, &#x60;varchar&#x60;, &#x60;text&#x60;, &#x60;varchar_auto&#x60;, &#x60;double&#x60;, &#x60;monetary&#x60; and &#x60;phone&#x60;. Read more about searching by custom fields &lt;a href&#x3D;\&quot;https://support.pipedrive.com/en/article/search-finding-what-you-need#searching-by-custom-fields\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener noreferrer\&quot;&gt;here&lt;/a&gt;.
     * @param {boolean} [exact_match] When enabled, only full exact matches against the given term are returned. It is &lt;b&gt;not&lt;/b&gt; case sensitive.
     * @param {number} [person_id] Will filter deals by the provided person ID. The upper limit of found deals associated with the person is 2000.
     * @param {number} [organization_id] Will filter deals by the provided organization ID. The upper limit of found deals associated with the organization is 2000.
     * @param {'open' | 'won' | 'lost'} [status] Will filter deals by the provided specific status. open &#x3D; Open, won &#x3D; Won, lost &#x3D; Lost. The upper limit of found deals associated with the status is 2000.
     * @param {'deal.cc_email'} [include_fields] Supports including optional fields in the results which are not provided by default
     * @param {number} [limit] For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @param {string} [cursor] For pagination, the marker (an opaque string value) representing the first item on the next page

     * @throws {RequiredError}
     */
    searchDeals(term: string, fields?: 'custom_fields' | 'notes' | 'title', exact_match?: boolean, person_id?: number, organization_id?: number, status?: 'open' | 'won' | 'lost', include_fields?: 'deal.cc_email', limit?: number, cursor?: string): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<GetDealSearchResponse>>;
    /**
     * Edits a discount added to a deal, changing the deal value if the deal has one-time products attached.
     * @summary Update a discount added to a deal
     * @param {number} id The ID of the deal
     * @param {number} discount_id The ID of the discount
     * @param {UpdateAdditionalDiscountRequestBody} [UpdateAdditionalDiscountRequestBody]

     * @throws {RequiredError}
     */
    updateAdditionalDiscount(id: number, discount_id: number, UpdateAdditionalDiscountRequestBody?: UpdateAdditionalDiscountRequestBody): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpdateAdditionalDiscountResponse>>;
    /**
     * Updates the properties of a deal.
     * @summary Update a deal
     * @param {number} id The ID of the deal
     * @param {UpdateDealRequest} [UpdateDealRequest]

     * @throws {RequiredError}
     */
    updateDeal(id: number, UpdateDealRequest?: UpdateDealRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpsertDealResponse>>;
    /**
     * Updates the details of the product that has been attached to a deal.
     * @summary Update the product attached to a deal
     * @param {number} id The ID of the deal
     * @param {number} product_attachment_id The ID of the deal-product (the ID of the product attached to the deal)
     * @param {UpdateDealProductRequest} [UpdateDealProductRequest]

     * @throws {RequiredError}
     */
    updateDealProduct(id: number, product_attachment_id: number, UpdateDealProductRequest?: UpdateDealProductRequest): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AddDealProductResponse>>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {number} id The ID of the deal
     * @param {number} installment_id The ID of the installment
     * @param {UpdateInstallmentRequestBody} [UpdateInstallmentRequestBody]

     * @throws {RequiredError}
     */
    updateInstallment(id: number, installment_id: number, UpdateInstallmentRequestBody?: UpdateInstallmentRequestBody): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<UpdateInstallmentResponse>>;
};
/**
 * DealsApi - factory interface
 * @export
 */
export declare const DealsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     * Adds a new deal.
     * @summary Add a new deal
     * @param {DealsApiAddDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    addDeal(requestParameters?: DealsApiAddDealRequest): Promise<UpsertDealResponse>;
    /**
     * Adds a user as a follower to the deal.
     * @summary Add a follower to a deal
     * @param {DealsApiAddDealFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    addDealFollower(requestParameters: DealsApiAddDealFollowerRequest): Promise<AddFollowerResponse>;
    /**
     * Adds a product to a deal, creating a new item called a deal-product.
     * @summary Add a product to a deal
     * @param {DealsApiAddDealProductRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    addDealProduct(requestParameters: DealsApiAddDealProductRequest): Promise<AddDealProductResponse>;
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {DealsApiConvertDealToLeadRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    convertDealToLead(requestParameters: DealsApiConvertDealToLeadRequest): Promise<AddConvertDealToLeadResponse>;
    /**
     * Removes a discount from a deal, changing the deal value if the deal has one-time products attached.
     * @summary Delete a discount from a deal
     * @param {DealsApiDeleteAdditionalDiscountRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteAdditionalDiscount(requestParameters: DealsApiDeleteAdditionalDiscountRequest): Promise<DeleteAdditionalDiscountResponse>;
    /**
     * Marks a deal as deleted. After 30 days, the deal will be permanently deleted.
     * @summary Delete a deal
     * @param {DealsApiDeleteDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteDeal(requestParameters: DealsApiDeleteDealRequest): Promise<DeleteDealResponse>;
    /**
     * Deletes a user follower from the deal.
     * @summary Delete a follower from a deal
     * @param {DealsApiDeleteDealFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteDealFollower(requestParameters: DealsApiDeleteDealFollowerRequest): Promise<DeleteFollowerResponse>;
    /**
     * Deletes a product attachment from a deal, using the `product_attachment_id`.
     * @summary Delete an attached product from a deal
     * @param {DealsApiDeleteDealProductRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteDealProduct(requestParameters: DealsApiDeleteDealProductRequest): Promise<DeleteDealProductResponse>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {DealsApiDeleteInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    deleteInstallment(requestParameters: DealsApiDeleteInstallmentRequest): Promise<DeleteInstallmentResponse>;
    /**
     * Lists discounts attached to a deal.
     * @summary List discounts added to a deal
     * @param {DealsApiGetAdditionalDiscountsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getAdditionalDiscounts(requestParameters: DealsApiGetAdditionalDiscountsRequest): Promise<GetAdditionalDiscountsResponse>;
    /**
     * Returns data about all archived deals.
     * @summary Get all archived deals
     * @param {DealsApiGetArchivedDealsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getArchivedDeals(requestParameters?: DealsApiGetArchivedDealsRequest): Promise<GetDealsResponse>;
    /**
     * Returns the details of a specific deal.
     * @summary Get details of a deal
     * @param {DealsApiGetDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDeal(requestParameters: DealsApiGetDealRequest): Promise<UpsertDealResponse>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {DealsApiGetDealConversionStatusRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDealConversionStatus(requestParameters: DealsApiGetDealConversionStatusRequest): Promise<GetConvertResponse1>;
    /**
     * Lists users who are following the deal.
     * @summary List followers of a deal
     * @param {DealsApiGetDealFollowersRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDealFollowers(requestParameters: DealsApiGetDealFollowersRequest): Promise<GetFollowersResponse>;
    /**
     * Lists changelogs about users have followed the deal.
     * @summary List followers changelog of a deal
     * @param {DealsApiGetDealFollowersChangelogRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDealFollowersChangelog(requestParameters: DealsApiGetDealFollowersChangelogRequest): Promise<GetFollowerChangelogsResponse>;
    /**
     * Lists products attached to a deal.
     * @summary List products attached to a deal
     * @param {DealsApiGetDealProductsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDealProducts(requestParameters: DealsApiGetDealProductsRequest): Promise<GetDealsProductsResponse>;
    /**
     * Returns data about all not archived deals.
     * @summary Get all deals
     * @param {DealsApiGetDealsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDeals(requestParameters?: DealsApiGetDealsRequest): Promise<GetDealsResponse>;
    /**
     * Returns data about products attached to deals
     * @summary Get deal products of several deals
     * @param {DealsApiGetDealsProductsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getDealsProducts(requestParameters: DealsApiGetDealsProductsRequest): Promise<GetDealsProductsResponse>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {DealsApiGetInstallmentsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    getInstallments(requestParameters: DealsApiGetInstallmentsRequest): Promise<GetInstallmentsResponse>;
    /**
     * Adds a discount to a deal changing, the deal value if the deal has one-time products attached.
     * @summary Add a discount to a deal
     * @param {DealsApiPostAdditionalDiscountRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    postAdditionalDiscount(requestParameters: DealsApiPostAdditionalDiscountRequest): Promise<AddAdditionalDiscountResponse>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {DealsApiPostInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    postInstallment(requestParameters: DealsApiPostInstallmentRequest): Promise<AddAInstallmentResponse>;
    /**
     * Searches all deals by title, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope. Found deals can be filtered by the person ID and the organization ID.
     * @summary Search deals
     * @param {DealsApiSearchDealsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    searchDeals(requestParameters: DealsApiSearchDealsRequest): Promise<GetDealSearchResponse>;
    /**
     * Edits a discount added to a deal, changing the deal value if the deal has one-time products attached.
     * @summary Update a discount added to a deal
     * @param {DealsApiUpdateAdditionalDiscountRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    updateAdditionalDiscount(requestParameters: DealsApiUpdateAdditionalDiscountRequest): Promise<UpdateAdditionalDiscountResponse>;
    /**
     * Updates the properties of a deal.
     * @summary Update a deal
     * @param {DealsApiUpdateDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    updateDeal(requestParameters: DealsApiUpdateDealRequest): Promise<UpsertDealResponse>;
    /**
     * Updates the details of the product that has been attached to a deal.
     * @summary Update the product attached to a deal
     * @param {DealsApiUpdateDealProductRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    updateDealProduct(requestParameters: DealsApiUpdateDealProductRequest): Promise<AddDealProductResponse>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {DealsApiUpdateInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     */
    updateInstallment(requestParameters: DealsApiUpdateInstallmentRequest): Promise<UpdateInstallmentResponse>;
};
/**
 * Request parameters for addDeal operation in DealsApi.
 * @export
 * @interface DealsApiAddDealRequest
 */
export interface DealsApiAddDealRequest {
    /**
     *
     * @type {AddDealRequest}
     * @memberof DealsApiAddDeal
     */
    readonly AddDealRequest?: AddDealRequest;
}
/**
 * Request parameters for addDealFollower operation in DealsApi.
 * @export
 * @interface DealsApiAddDealFollowerRequest
 */
export interface DealsApiAddDealFollowerRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiAddDealFollower
     */
    readonly id: number;
    /**
     *
     * @type {AddDealFollowerRequest}
     * @memberof DealsApiAddDealFollower
     */
    readonly AddDealFollowerRequest?: AddDealFollowerRequest;
}
/**
 * Request parameters for addDealProduct operation in DealsApi.
 * @export
 * @interface DealsApiAddDealProductRequest
 */
export interface DealsApiAddDealProductRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiAddDealProduct
     */
    readonly id: number;
    /**
     *
     * @type {AddDealProductRequest}
     * @memberof DealsApiAddDealProduct
     */
    readonly AddDealProductRequest?: AddDealProductRequest;
}
/**
 * Request parameters for convertDealToLead operation in DealsApi.
 * @export
 * @interface DealsApiConvertDealToLeadRequest
 */
export interface DealsApiConvertDealToLeadRequest {
    /**
     * The ID of the deal to convert
     * @type {number}
     * @memberof DealsApiConvertDealToLead
     */
    readonly id: number;
}
/**
 * Request parameters for deleteAdditionalDiscount operation in DealsApi.
 * @export
 * @interface DealsApiDeleteAdditionalDiscountRequest
 */
export interface DealsApiDeleteAdditionalDiscountRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiDeleteAdditionalDiscount
     */
    readonly id: number;
    /**
     * The ID of the discount
     * @type {number}
     * @memberof DealsApiDeleteAdditionalDiscount
     */
    readonly discount_id: number;
}
/**
 * Request parameters for deleteDeal operation in DealsApi.
 * @export
 * @interface DealsApiDeleteDealRequest
 */
export interface DealsApiDeleteDealRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiDeleteDeal
     */
    readonly id: number;
}
/**
 * Request parameters for deleteDealFollower operation in DealsApi.
 * @export
 * @interface DealsApiDeleteDealFollowerRequest
 */
export interface DealsApiDeleteDealFollowerRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiDeleteDealFollower
     */
    readonly id: number;
    /**
     * The ID of the following user
     * @type {number}
     * @memberof DealsApiDeleteDealFollower
     */
    readonly follower_id: number;
}
/**
 * Request parameters for deleteDealProduct operation in DealsApi.
 * @export
 * @interface DealsApiDeleteDealProductRequest
 */
export interface DealsApiDeleteDealProductRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiDeleteDealProduct
     */
    readonly id: number;
    /**
     * The product attachment ID
     * @type {number}
     * @memberof DealsApiDeleteDealProduct
     */
    readonly product_attachment_id: number;
}
/**
 * Request parameters for deleteInstallment operation in DealsApi.
 * @export
 * @interface DealsApiDeleteInstallmentRequest
 */
export interface DealsApiDeleteInstallmentRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiDeleteInstallment
     */
    readonly id: number;
    /**
     * The ID of the installment
     * @type {number}
     * @memberof DealsApiDeleteInstallment
     */
    readonly installment_id: number;
}
/**
 * Request parameters for getAdditionalDiscounts operation in DealsApi.
 * @export
 * @interface DealsApiGetAdditionalDiscountsRequest
 */
export interface DealsApiGetAdditionalDiscountsRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiGetAdditionalDiscounts
     */
    readonly id: number;
}
/**
 * Request parameters for getArchivedDeals operation in DealsApi.
 * @export
 * @interface DealsApiGetArchivedDealsRequest
 */
export interface DealsApiGetArchivedDealsRequest {
    /**
     * If supplied, only deals matching the specified filter are returned
     * @type {number}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly filter_id?: number;
    /**
     * Optional comma separated string array of up to 100 entity ids to fetch. If filter_id is provided, this is ignored. If any of the requested entities do not exist or are not visible, they are not included in the response.
     * @type {string}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly ids?: string;
    /**
     * If supplied, only deals owned by the specified user are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly owner_id?: number;
    /**
     * If supplied, only deals linked to the specified person are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly person_id?: number;
    /**
     * If supplied, only deals linked to the specified organization are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly org_id?: number;
    /**
     * If supplied, only deals in the specified pipeline are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly pipeline_id?: number;
    /**
     * If supplied, only deals in the specified stage are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly stage_id?: number;
    /**
     * Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included. Multiple statuses can be included as a comma separated array. If filter_id is provided, this is ignored.
     * @type {'open' | 'won' | 'lost' | 'deleted'}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly status?: 'open' | 'won' | 'lost' | 'deleted';
    /**
     * If set, only deals with an &#x60;update_time&#x60; later than or equal to this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @type {string}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly updated_since?: string;
    /**
     * If set, only deals with an &#x60;update_time&#x60; earlier than this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @type {string}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly updated_until?: string;
    /**
     * The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;, &#x60;add_time&#x60;.
     * @type {'id' | 'update_time' | 'add_time'}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly sort_by?: 'id' | 'update_time' | 'add_time';
    /**
     * The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @type {'asc' | 'desc'}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly sort_direction?: 'asc' | 'desc';
    /**
     * Optional comma separated string array of additional fields to include
     * @type {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email';
    /**
     * Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.
     * @type {string}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly custom_fields?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly limit?: number;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiGetArchivedDeals
     */
    readonly cursor?: string;
}
/**
 * Request parameters for getDeal operation in DealsApi.
 * @export
 * @interface DealsApiGetDealRequest
 */
export interface DealsApiGetDealRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiGetDeal
     */
    readonly id: number;
    /**
     * Optional comma separated string array of additional fields to include
     * @type {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'}
     * @memberof DealsApiGetDeal
     */
    readonly include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email';
    /**
     * Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.
     * @type {string}
     * @memberof DealsApiGetDeal
     */
    readonly custom_fields?: string;
}
/**
 * Request parameters for getDealConversionStatus operation in DealsApi.
 * @export
 * @interface DealsApiGetDealConversionStatusRequest
 */
export interface DealsApiGetDealConversionStatusRequest {
    /**
     * The ID of a deal
     * @type {number}
     * @memberof DealsApiGetDealConversionStatus
     */
    readonly id: number;
    /**
     * The ID of the conversion
     * @type {string}
     * @memberof DealsApiGetDealConversionStatus
     */
    readonly conversion_id: string;
}
/**
 * Request parameters for getDealFollowers operation in DealsApi.
 * @export
 * @interface DealsApiGetDealFollowersRequest
 */
export interface DealsApiGetDealFollowersRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiGetDealFollowers
     */
    readonly id: number;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiGetDealFollowers
     */
    readonly limit?: number;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiGetDealFollowers
     */
    readonly cursor?: string;
}
/**
 * Request parameters for getDealFollowersChangelog operation in DealsApi.
 * @export
 * @interface DealsApiGetDealFollowersChangelogRequest
 */
export interface DealsApiGetDealFollowersChangelogRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiGetDealFollowersChangelog
     */
    readonly id: number;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiGetDealFollowersChangelog
     */
    readonly limit?: number;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiGetDealFollowersChangelog
     */
    readonly cursor?: string;
}
/**
 * Request parameters for getDealProducts operation in DealsApi.
 * @export
 * @interface DealsApiGetDealProductsRequest
 */
export interface DealsApiGetDealProductsRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiGetDealProducts
     */
    readonly id: number;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiGetDealProducts
     */
    readonly cursor?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiGetDealProducts
     */
    readonly limit?: number;
    /**
     * The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;add_time&#x60;, &#x60;update_time&#x60;.
     * @type {'id' | 'add_time' | 'update_time'}
     * @memberof DealsApiGetDealProducts
     */
    readonly sort_by?: 'id' | 'add_time' | 'update_time';
    /**
     * The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @type {'asc' | 'desc'}
     * @memberof DealsApiGetDealProducts
     */
    readonly sort_direction?: 'asc' | 'desc';
}
/**
 * Request parameters for getDeals operation in DealsApi.
 * @export
 * @interface DealsApiGetDealsRequest
 */
export interface DealsApiGetDealsRequest {
    /**
     * If supplied, only deals matching the specified filter are returned
     * @type {number}
     * @memberof DealsApiGetDeals
     */
    readonly filter_id?: number;
    /**
     * Optional comma separated string array of up to 100 entity ids to fetch. If filter_id is provided, this is ignored. If any of the requested entities do not exist or are not visible, they are not included in the response.
     * @type {string}
     * @memberof DealsApiGetDeals
     */
    readonly ids?: string;
    /**
     * If supplied, only deals owned by the specified user are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetDeals
     */
    readonly owner_id?: number;
    /**
     * If supplied, only deals linked to the specified person are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetDeals
     */
    readonly person_id?: number;
    /**
     * If supplied, only deals linked to the specified organization are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetDeals
     */
    readonly org_id?: number;
    /**
     * If supplied, only deals in the specified pipeline are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetDeals
     */
    readonly pipeline_id?: number;
    /**
     * If supplied, only deals in the specified stage are returned. If filter_id is provided, this is ignored.
     * @type {number}
     * @memberof DealsApiGetDeals
     */
    readonly stage_id?: number;
    /**
     * Only fetch deals with a specific status. If omitted, all not deleted deals are returned. If set to deleted, deals that have been deleted up to 30 days ago will be included. Multiple statuses can be included as a comma separated array. If filter_id is provided, this is ignored.
     * @type {'open' | 'won' | 'lost' | 'deleted'}
     * @memberof DealsApiGetDeals
     */
    readonly status?: 'open' | 'won' | 'lost' | 'deleted';
    /**
     * If set, only deals with an &#x60;update_time&#x60; later than or equal to this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @type {string}
     * @memberof DealsApiGetDeals
     */
    readonly updated_since?: string;
    /**
     * If set, only deals with an &#x60;update_time&#x60; earlier than this time are returned. In RFC3339 format, e.g. 2025-01-01T10:20:00Z.
     * @type {string}
     * @memberof DealsApiGetDeals
     */
    readonly updated_until?: string;
    /**
     * The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;update_time&#x60;, &#x60;add_time&#x60;.
     * @type {'id' | 'update_time' | 'add_time'}
     * @memberof DealsApiGetDeals
     */
    readonly sort_by?: 'id' | 'update_time' | 'add_time';
    /**
     * The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @type {'asc' | 'desc'}
     * @memberof DealsApiGetDeals
     */
    readonly sort_direction?: 'asc' | 'desc';
    /**
     * Optional comma separated string array of additional fields to include
     * @type {'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email'}
     * @memberof DealsApiGetDeals
     */
    readonly include_fields?: 'next_activity_id' | 'last_activity_id' | 'first_won_time' | 'products_count' | 'files_count' | 'notes_count' | 'followers_count' | 'email_messages_count' | 'activities_count' | 'done_activities_count' | 'undone_activities_count' | 'participants_count' | 'last_incoming_mail_time' | 'last_outgoing_mail_time' | 'smart_bcc_email';
    /**
     * Optional comma separated string array of custom fields keys to include. If you are only interested in a particular set of custom fields, please use this parameter for faster results and smaller response.&lt;br/&gt;A maximum of 15 keys is allowed.
     * @type {string}
     * @memberof DealsApiGetDeals
     */
    readonly custom_fields?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiGetDeals
     */
    readonly limit?: number;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiGetDeals
     */
    readonly cursor?: string;
}
/**
 * Request parameters for getDealsProducts operation in DealsApi.
 * @export
 * @interface DealsApiGetDealsProductsRequest
 */
export interface DealsApiGetDealsProductsRequest {
    /**
     * An array of integers with the IDs of the deals for which the attached products will be returned. A maximum of 100 deal IDs can be provided.
     * @type {Array<number>}
     * @memberof DealsApiGetDealsProducts
     */
    readonly deal_ids: Array<number>;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiGetDealsProducts
     */
    readonly cursor?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiGetDealsProducts
     */
    readonly limit?: number;
    /**
     * The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;deal_id&#x60;, &#x60;add_time&#x60;, &#x60;update_time&#x60;.
     * @type {'id' | 'deal_id' | 'add_time' | 'update_time'}
     * @memberof DealsApiGetDealsProducts
     */
    readonly sort_by?: 'id' | 'deal_id' | 'add_time' | 'update_time';
    /**
     * The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @type {'asc' | 'desc'}
     * @memberof DealsApiGetDealsProducts
     */
    readonly sort_direction?: 'asc' | 'desc';
}
/**
 * Request parameters for getInstallments operation in DealsApi.
 * @export
 * @interface DealsApiGetInstallmentsRequest
 */
export interface DealsApiGetInstallmentsRequest {
    /**
     * An array of integers with the IDs of the deals for which the attached installments will be returned. A maximum of 100 deal IDs can be provided.
     * @type {Array<number>}
     * @memberof DealsApiGetInstallments
     */
    readonly deal_ids: Array<number>;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiGetInstallments
     */
    readonly cursor?: string;
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiGetInstallments
     */
    readonly limit?: number;
    /**
     * The field to sort by. Supported fields: &#x60;id&#x60;, &#x60;billing_date&#x60;, &#x60;deal_id&#x60;.
     * @type {'id' | 'billing_date' | 'deal_id'}
     * @memberof DealsApiGetInstallments
     */
    readonly sort_by?: 'id' | 'billing_date' | 'deal_id';
    /**
     * The sorting direction. Supported values: &#x60;asc&#x60;, &#x60;desc&#x60;.
     * @type {'asc' | 'desc'}
     * @memberof DealsApiGetInstallments
     */
    readonly sort_direction?: 'asc' | 'desc';
}
/**
 * Request parameters for postAdditionalDiscount operation in DealsApi.
 * @export
 * @interface DealsApiPostAdditionalDiscountRequest
 */
export interface DealsApiPostAdditionalDiscountRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiPostAdditionalDiscount
     */
    readonly id: number;
    /**
     *
     * @type {AddAdditionalDiscountRequestBody}
     * @memberof DealsApiPostAdditionalDiscount
     */
    readonly AddAdditionalDiscountRequestBody?: AddAdditionalDiscountRequestBody;
}
/**
 * Request parameters for postInstallment operation in DealsApi.
 * @export
 * @interface DealsApiPostInstallmentRequest
 */
export interface DealsApiPostInstallmentRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiPostInstallment
     */
    readonly id: number;
    /**
     *
     * @type {AddInstallmentRequestBody}
     * @memberof DealsApiPostInstallment
     */
    readonly AddInstallmentRequestBody?: AddInstallmentRequestBody;
}
/**
 * Request parameters for searchDeals operation in DealsApi.
 * @export
 * @interface DealsApiSearchDealsRequest
 */
export interface DealsApiSearchDealsRequest {
    /**
     * The search term to look for. Minimum 2 characters (or 1 if using &#x60;exact_match&#x60;). Please note that the search term has to be URL encoded.
     * @type {string}
     * @memberof DealsApiSearchDeals
     */
    readonly term: string;
    /**
     * A comma-separated string array. The fields to perform the search from. Defaults to all of them. Only the following custom field types are searchable: &#x60;address&#x60;, &#x60;varchar&#x60;, &#x60;text&#x60;, &#x60;varchar_auto&#x60;, &#x60;double&#x60;, &#x60;monetary&#x60; and &#x60;phone&#x60;. Read more about searching by custom fields &lt;a href&#x3D;\&quot;https://support.pipedrive.com/en/article/search-finding-what-you-need#searching-by-custom-fields\&quot; target&#x3D;\&quot;_blank\&quot; rel&#x3D;\&quot;noopener noreferrer\&quot;&gt;here&lt;/a&gt;.
     * @type {'custom_fields' | 'notes' | 'title'}
     * @memberof DealsApiSearchDeals
     */
    readonly fields?: 'custom_fields' | 'notes' | 'title';
    /**
     * When enabled, only full exact matches against the given term are returned. It is &lt;b&gt;not&lt;/b&gt; case sensitive.
     * @type {boolean}
     * @memberof DealsApiSearchDeals
     */
    readonly exact_match?: boolean;
    /**
     * Will filter deals by the provided person ID. The upper limit of found deals associated with the person is 2000.
     * @type {number}
     * @memberof DealsApiSearchDeals
     */
    readonly person_id?: number;
    /**
     * Will filter deals by the provided organization ID. The upper limit of found deals associated with the organization is 2000.
     * @type {number}
     * @memberof DealsApiSearchDeals
     */
    readonly organization_id?: number;
    /**
     * Will filter deals by the provided specific status. open &#x3D; Open, won &#x3D; Won, lost &#x3D; Lost. The upper limit of found deals associated with the status is 2000.
     * @type {'open' | 'won' | 'lost'}
     * @memberof DealsApiSearchDeals
     */
    readonly status?: 'open' | 'won' | 'lost';
    /**
     * Supports including optional fields in the results which are not provided by default
     * @type {'deal.cc_email'}
     * @memberof DealsApiSearchDeals
     */
    readonly include_fields?: 'deal.cc_email';
    /**
     * For pagination, the limit of entries to be returned. If not provided, 100 items will be returned. Please note that a maximum value of 500 is allowed.
     * @type {number}
     * @memberof DealsApiSearchDeals
     */
    readonly limit?: number;
    /**
     * For pagination, the marker (an opaque string value) representing the first item on the next page
     * @type {string}
     * @memberof DealsApiSearchDeals
     */
    readonly cursor?: string;
}
/**
 * Request parameters for updateAdditionalDiscount operation in DealsApi.
 * @export
 * @interface DealsApiUpdateAdditionalDiscountRequest
 */
export interface DealsApiUpdateAdditionalDiscountRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiUpdateAdditionalDiscount
     */
    readonly id: number;
    /**
     * The ID of the discount
     * @type {number}
     * @memberof DealsApiUpdateAdditionalDiscount
     */
    readonly discount_id: number;
    /**
     *
     * @type {UpdateAdditionalDiscountRequestBody}
     * @memberof DealsApiUpdateAdditionalDiscount
     */
    readonly UpdateAdditionalDiscountRequestBody?: UpdateAdditionalDiscountRequestBody;
}
/**
 * Request parameters for updateDeal operation in DealsApi.
 * @export
 * @interface DealsApiUpdateDealRequest
 */
export interface DealsApiUpdateDealRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiUpdateDeal
     */
    readonly id: number;
    /**
     *
     * @type {UpdateDealRequest}
     * @memberof DealsApiUpdateDeal
     */
    readonly UpdateDealRequest?: UpdateDealRequest;
}
/**
 * Request parameters for updateDealProduct operation in DealsApi.
 * @export
 * @interface DealsApiUpdateDealProductRequest
 */
export interface DealsApiUpdateDealProductRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiUpdateDealProduct
     */
    readonly id: number;
    /**
     * The ID of the deal-product (the ID of the product attached to the deal)
     * @type {number}
     * @memberof DealsApiUpdateDealProduct
     */
    readonly product_attachment_id: number;
    /**
     *
     * @type {UpdateDealProductRequest}
     * @memberof DealsApiUpdateDealProduct
     */
    readonly UpdateDealProductRequest?: UpdateDealProductRequest;
}
/**
 * Request parameters for updateInstallment operation in DealsApi.
 * @export
 * @interface DealsApiUpdateInstallmentRequest
 */
export interface DealsApiUpdateInstallmentRequest {
    /**
     * The ID of the deal
     * @type {number}
     * @memberof DealsApiUpdateInstallment
     */
    readonly id: number;
    /**
     * The ID of the installment
     * @type {number}
     * @memberof DealsApiUpdateInstallment
     */
    readonly installment_id: number;
    /**
     *
     * @type {UpdateInstallmentRequestBody}
     * @memberof DealsApiUpdateInstallment
     */
    readonly UpdateInstallmentRequestBody?: UpdateInstallmentRequestBody;
}
/**
 * DealsApi - object-oriented interface
 * @export
 * @class DealsApi
 * @extends {BaseAPI}
 */
export declare class DealsApi extends BaseAPI {
    /**
     * Adds a new deal.
     * @summary Add a new deal
     * @param {DealsApiAddDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    addDeal(requestParameters?: DealsApiAddDealRequest): Promise<UpsertDealResponse>;
    /**
     * Adds a user as a follower to the deal.
     * @summary Add a follower to a deal
     * @param {DealsApiAddDealFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    addDealFollower(requestParameters: DealsApiAddDealFollowerRequest): Promise<AddFollowerResponse>;
    /**
     * Adds a product to a deal, creating a new item called a deal-product.
     * @summary Add a product to a deal
     * @param {DealsApiAddDealProductRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    addDealProduct(requestParameters: DealsApiAddDealProductRequest): Promise<AddDealProductResponse>;
    /**
     * Initiates a conversion of a deal to a lead. The return value is an ID of a job that was assigned to perform the conversion. Related entities (notes, files, emails, activities, ...) are transferred during the process to the target entity. There are exceptions for entities like invoices or history that are not transferred and remain linked to the original deal. If the conversion is successful, the deal is marked as deleted. To retrieve the created entity ID and the result of the conversion, call the <a href=\"https://developers.pipedrive.com/docs/api/v1/Deals#getDealConversionStatus\">/api/v2/deals/{deal_id}/convert/status/{conversion_id}</a> endpoint.
     * @summary Convert a deal to a lead (BETA)
     * @param {DealsApiConvertDealToLeadRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    convertDealToLead(requestParameters: DealsApiConvertDealToLeadRequest): Promise<AddConvertDealToLeadResponse>;
    /**
     * Removes a discount from a deal, changing the deal value if the deal has one-time products attached.
     * @summary Delete a discount from a deal
     * @param {DealsApiDeleteAdditionalDiscountRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    deleteAdditionalDiscount(requestParameters: DealsApiDeleteAdditionalDiscountRequest): Promise<DeleteAdditionalDiscountResponse>;
    /**
     * Marks a deal as deleted. After 30 days, the deal will be permanently deleted.
     * @summary Delete a deal
     * @param {DealsApiDeleteDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    deleteDeal(requestParameters: DealsApiDeleteDealRequest): Promise<DeleteDealResponse>;
    /**
     * Deletes a user follower from the deal.
     * @summary Delete a follower from a deal
     * @param {DealsApiDeleteDealFollowerRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    deleteDealFollower(requestParameters: DealsApiDeleteDealFollowerRequest): Promise<DeleteFollowerResponse>;
    /**
     * Deletes a product attachment from a deal, using the `product_attachment_id`.
     * @summary Delete an attached product from a deal
     * @param {DealsApiDeleteDealProductRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    deleteDealProduct(requestParameters: DealsApiDeleteDealProductRequest): Promise<DeleteDealProductResponse>;
    /**
     * Removes an installment from a deal.  Only available in Advanced and above plans.
     * @summary Delete an installment from a deal
     * @param {DealsApiDeleteInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    deleteInstallment(requestParameters: DealsApiDeleteInstallmentRequest): Promise<DeleteInstallmentResponse>;
    /**
     * Lists discounts attached to a deal.
     * @summary List discounts added to a deal
     * @param {DealsApiGetAdditionalDiscountsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getAdditionalDiscounts(requestParameters: DealsApiGetAdditionalDiscountsRequest): Promise<GetAdditionalDiscountsResponse>;
    /**
     * Returns data about all archived deals.
     * @summary Get all archived deals
     * @param {DealsApiGetArchivedDealsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getArchivedDeals(requestParameters?: DealsApiGetArchivedDealsRequest): Promise<GetDealsResponse>;
    /**
     * Returns the details of a specific deal.
     * @summary Get details of a deal
     * @param {DealsApiGetDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getDeal(requestParameters: DealsApiGetDealRequest): Promise<UpsertDealResponse>;
    /**
     * Returns information about the conversion. Status is always present and its value (not_started, running, completed, failed, rejected) represents the current state of the conversion. Lead ID is only present if the conversion was successfully finished. This data is only temporary and removed after a few days.
     * @summary Get Deal conversion status (BETA)
     * @param {DealsApiGetDealConversionStatusRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getDealConversionStatus(requestParameters: DealsApiGetDealConversionStatusRequest): Promise<GetConvertResponse1>;
    /**
     * Lists users who are following the deal.
     * @summary List followers of a deal
     * @param {DealsApiGetDealFollowersRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getDealFollowers(requestParameters: DealsApiGetDealFollowersRequest): Promise<GetFollowersResponse>;
    /**
     * Lists changelogs about users have followed the deal.
     * @summary List followers changelog of a deal
     * @param {DealsApiGetDealFollowersChangelogRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getDealFollowersChangelog(requestParameters: DealsApiGetDealFollowersChangelogRequest): Promise<GetFollowerChangelogsResponse>;
    /**
     * Lists products attached to a deal.
     * @summary List products attached to a deal
     * @param {DealsApiGetDealProductsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getDealProducts(requestParameters: DealsApiGetDealProductsRequest): Promise<GetDealsProductsResponse>;
    /**
     * Returns data about all not archived deals.
     * @summary Get all deals
     * @param {DealsApiGetDealsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getDeals(requestParameters?: DealsApiGetDealsRequest): Promise<GetDealsResponse>;
    /**
     * Returns data about products attached to deals
     * @summary Get deal products of several deals
     * @param {DealsApiGetDealsProductsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getDealsProducts(requestParameters: DealsApiGetDealsProductsRequest): Promise<GetDealsProductsResponse>;
    /**
     * Lists installments attached to a list of deals.  Only available in Advanced and above plans.
     * @summary List installments added to a list of deals
     * @param {DealsApiGetInstallmentsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    getInstallments(requestParameters: DealsApiGetInstallmentsRequest): Promise<GetInstallmentsResponse>;
    /**
     * Adds a discount to a deal changing, the deal value if the deal has one-time products attached.
     * @summary Add a discount to a deal
     * @param {DealsApiPostAdditionalDiscountRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    postAdditionalDiscount(requestParameters: DealsApiPostAdditionalDiscountRequest): Promise<AddAdditionalDiscountResponse>;
    /**
     * Adds an installment to a deal.  An installment can only be added if the deal includes at least one one-time product.  If the deal contains at least one recurring product, adding installments is not allowed.  Only available in Advanced and above plans.
     * @summary Add an installment to a deal
     * @param {DealsApiPostInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    postInstallment(requestParameters: DealsApiPostInstallmentRequest): Promise<AddAInstallmentResponse>;
    /**
     * Searches all deals by title, notes and/or custom fields. This endpoint is a wrapper of <a href=\"https://developers.pipedrive.com/docs/api/v1/ItemSearch#searchItem\">/v1/itemSearch</a> with a narrower OAuth scope. Found deals can be filtered by the person ID and the organization ID.
     * @summary Search deals
     * @param {DealsApiSearchDealsRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    searchDeals(requestParameters: DealsApiSearchDealsRequest): Promise<GetDealSearchResponse>;
    /**
     * Edits a discount added to a deal, changing the deal value if the deal has one-time products attached.
     * @summary Update a discount added to a deal
     * @param {DealsApiUpdateAdditionalDiscountRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    updateAdditionalDiscount(requestParameters: DealsApiUpdateAdditionalDiscountRequest): Promise<UpdateAdditionalDiscountResponse>;
    /**
     * Updates the properties of a deal.
     * @summary Update a deal
     * @param {DealsApiUpdateDealRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    updateDeal(requestParameters: DealsApiUpdateDealRequest): Promise<UpsertDealResponse>;
    /**
     * Updates the details of the product that has been attached to a deal.
     * @summary Update the product attached to a deal
     * @param {DealsApiUpdateDealProductRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    updateDealProduct(requestParameters: DealsApiUpdateDealProductRequest): Promise<AddDealProductResponse>;
    /**
     * Edits an installment added to a deal.  Only available in Advanced and above plans.
     * @summary Update an installment added to a deal
     * @param {DealsApiUpdateInstallmentRequest} requestParameters Request parameters.

     * @throws {RequiredError}
     * @memberof DealsApi
     */
    updateInstallment(requestParameters: DealsApiUpdateInstallmentRequest): Promise<UpdateInstallmentResponse>;
}
